/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef         __COMMUN
#define         __COMMUN
#include "Declaration.h"
#include "crypt-md5.h"
#define NUM_MAX_REGISTRATION 25
#define MAX_PORTS  30
#define KEY_FILE_RECEPTION_NOUVELLE_MACHINE 1200
#define KEY_FILE_DEMANDE 1201
#define KEY_FILE_MESSAGE 1199
#define KEY_FILE_MESSAGE_TEMP_REEL 1202

int       File_Reception_Nouvelle_Machine;
int       File_Envoie_Demande;
int       File_Envoie_Message;
int       File_Envoie_Message_Temps_Reel;

#define RE_SCAN_MACHINE	1
#define SCAN_SOUS_RESEAU 2
#define MACHINE_RESTAURER 3
#define ERREUR 4
#define WARNING 5
#define INFO 6
#define DEMANDE_ARRET_AUTOSCAN_D 7
#define DEMARRAGE_SCAN	8
#define ARRET_SCAN 9
#define RELECTURE_FICHIER_CONFIGURATION 10
#define RETOUR_SCRIPT 11
#define RETOUR_SCRIPT_TERMINE 12
#define	RETOUR_INFO 13
#define	AUTOSCAN_D_ARRETER 14
#define AUTOSCAN_SEGMENTATION_FAULT 15
#define DEMARRAGE_SANS_SCAN	16
#define REFRESH_MACHINE 17

struct struct_Message {
	long      type;
	char      type_message;
	char      donnee[255];
	int		  Nb_Machine_Dans_La_Liste; // nb total de machine ( machine restaure + machine détecté )
	int		  Nb_Machine_En_Cours_De_Scan;
	int		  Nb_Machine_En_Attente_De_Scan;
};


struct struct_Demande {
	long      type;
	char      type_demande;
	char      donnee[255];
	/* Utiliser seulement pour la restauration */
	unsigned char Adresse_Ip[16];
	unsigned long int AdresseIp;
	unsigned char Adresse_Mac[18];
	unsigned char AdresseMAC[6];
	/* Parametres utiliser lors du demarrage du scan */
	char      interface[10];
	int       Nb_Thread_Max;
};



/*********** Mise à jour temps réel ****************************************/
#define	ARRET_MACHINE 		1
#define DEMARRAGE_MACHINE 	2


struct struct_Message_Temps_Reel {
	long      type;
	char      type_message;
	unsigned char Mac_Adresse_Machine[6];
};

/***************************************************************************/

struct struct_Ports {
	int       Num_Port;
	int       Etat;		// ouvert ou firewalled
	int       Index_Port;
	int       Type_Machine;
	char     *Commentaire;
};


struct struct_Smb_Registration {
	unsigned char Type;	// GROUP ou UNIQUE
	unsigned char Name[16 + 1];
	unsigned char Numero;
};

struct struct_Smb {
	unsigned char HostName[16 + 1];
	unsigned char DomainName[16 + 1];
	unsigned char Utilisateur[16 + 1];
	struct struct_Smb_Registration Smb_Registration[NUM_MAX_REGISTRATION];
};

struct struct_Machines_Resultat {
	long      type;
	int       Num_Machine_Interface;
	unsigned char Adresse_Ip[16];
	unsigned long int AdresseIp;
	unsigned char Adresse_Mac[18];
	unsigned char AdresseMAC[6];
	/* Signature */
	md5_byte_t digest[16 + 1];
	/* Samba */
	struct struct_Smb Smb;
	/* Scan ports */
	gboolean      Serveur;	// boolean
	int		  Nb_Port_Total_Scanner;
	int       Nb_Port_Ouvert;
	int		  Nb_Port_Fermer;
	int		  Nb_Port_Firewaller;
	struct struct_Ports Port[MAX_PORTS];
	/* Utiliser pour la barre de progression */
	int		  Nb_Machine_Dans_La_Liste; // nb total de machine ( machine restaure + machine détecté )
	int		  Nb_Machine_En_Cours_De_Scan;
	int		  Nb_Machine_En_Attente_De_Scan;
};


#endif
