/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <time.h>
#include "Reseau.h"
#include "OS_Detect.h"



void Nouvelle_Requete_Icmp_Timestamp (struct struct_Reponse *Reponse, int Machine, char *Icmp_Timestamp)
{
	struct sockaddr sock;
	int       Socket, Taille_Trame;
	unsigned short Id_Ip, Icmp_Id, Icmp_Seq, Icmp_Id_Retour, Icmp_Seq_Retour,Id_Ip_Retour;
	struct struct_trame Packet_Icmp_Timestamp, PacketReponse;
	unsigned short CheckSum_Calc;
	unsigned int Taille_Ip_En_Cours, Taille_Datagramme_IP_En_Cours;
	int       seconde_Debut, seconde_Ecoule, seconde_Actuelle, seconde_Next;
	int       Etat;
	gboolean  Fin;
	time_t    temps;
	struct tm *tm;


	usleep (300);
	bzero (Reponse, sizeof (struct struct_Reponse));
	Id_Ip = (unsigned short) random ();
	Icmp_Id = (unsigned short) random ();
	Icmp_Seq = (unsigned short) random ();
	strcpy (sock.sa_data, Interface);
	sock.sa_family = AF_INET;
	if ((Socket = socket (AF_INET, SOCK_PACKET, htons (ETH_P_ALL))) < 0) {
		perror ("[S] Socket: ");
		exit (1);
	}
	set_NonBlock (Socket);
	memcpy (&Packet_Icmp_Timestamp.Dest_MAC, &Liste_Machines[Machine].AdresseMAC, ETH_ALEN);
	memcpy (&Packet_Icmp_Timestamp.Source_MAC, MonAdresseMac, ETH_ALEN);
	Packet_Icmp_Timestamp.Proto = htons (TRAME_IP);
	memcpy (&Packet_Icmp_Timestamp.Datagramme, Icmp_Timestamp, 40);
	Packet_Icmp_Timestamp.Datagramme[4] = (Id_Ip >> 8) & 0xFF;
	Packet_Icmp_Timestamp.Datagramme[5] = Id_Ip & 0xFF;
	memcpy (&Packet_Icmp_Timestamp.Datagramme[12], &MonAdresseIp, IP_ADDR_LEN);
	memcpy (&Packet_Icmp_Timestamp.Datagramme[16], &Liste_Machines[Machine].AdresseIp, IP_ADDR_LEN);
	CheckSum_Calc = htons (ckecksum (&Packet_Icmp_Timestamp.Datagramme[0], 20, 0));
	memcpy (&Packet_Icmp_Timestamp.Datagramme[10], &CheckSum_Calc, 2);
	Packet_Icmp_Timestamp.Datagramme[24] = (Icmp_Id >> 8) & 0xFF;
	Packet_Icmp_Timestamp.Datagramme[25] = Icmp_Id & 0xFF;
	Packet_Icmp_Timestamp.Datagramme[26] = (Icmp_Seq >> 8) & 0xFF;
	Packet_Icmp_Timestamp.Datagramme[27] = Icmp_Seq & 0xFF;
	CheckSum_Calc = ckecksum (&Packet_Icmp_Timestamp.Datagramme[20], 20, 0);	//taille + protocole
	CheckSum_Calc = htons (CheckSum_Calc);
	memcpy (&Packet_Icmp_Timestamp.Datagramme[22], &CheckSum_Calc, 2);
	if ((sendto (Socket, &Packet_Icmp_Timestamp, 54, 0, &sock, sizeof (sock))) < 0) {
		perror ("[S] Erreur : Envoie packet Icmp_Timestamp");
		exit (-1);
	}

	time (&temps);
	tm = localtime (&temps);
	seconde_Debut = tm->tm_sec;
	seconde_Next = seconde_Debut;
	seconde_Ecoule = 0;
	Fin = FALSE;		// boolean
	while (!Fin) {		// boolean
		if (waiting_donnee (Socket, 1000)) {
			Taille_Trame = recvfrom (Socket, &PacketReponse, sizeof (struct struct_trame), 0, NULL, 0);
			if ((memcmp (PacketReponse.Source_MAC, Liste_Machines[Machine].AdresseMAC, ETH_ALEN) == 0)
				&& (memcmp (PacketReponse.Dest_MAC, MonAdresseMac, ETH_ALEN) == 0)) {
				if ((htons (PacketReponse.Proto) == TRAME_IP) && ((PacketReponse.Datagramme[0] >> 4) == IP_VERSION4) && (PacketReponse.Datagramme[9] == ICMP)) {
					if ((memcmp (&PacketReponse.Datagramme[16], &MonAdresseIp, IP_ADDR_LEN) == 0)
						&& (memcmp (&PacketReponse.Datagramme[12], &Liste_Machines[Machine].AdresseIp, IP_ADDR_LEN) == 0)) {
						Taille_Ip_En_Cours = (PacketReponse.Datagramme[0] & 0x0F) << 2;
						Taille_Datagramme_IP_En_Cours = (PacketReponse.Datagramme[2] << 8) + PacketReponse.Datagramme[3];
						printf ("Trame ICMP recupere   %d  %d \n", PacketReponse.Datagramme[Taille_Ip_En_Cours], PacketReponse.Datagramme[Taille_Ip_En_Cours+1]);
						memcpy (&Icmp_Id_Retour, &PacketReponse.Datagramme[Taille_Ip_En_Cours + 4], 2);
						Icmp_Id_Retour = htons (Icmp_Id_Retour);
						memcpy (&Icmp_Seq_Retour, &PacketReponse.Datagramme[Taille_Ip_En_Cours + 6], 2);
						Icmp_Seq_Retour = htons (Icmp_Seq_Retour);
						printf("ICMP Timestamp  %04X   %04X\n",Icmp_Id_Retour,Icmp_Seq_Retour);
						if ((PacketReponse.Datagramme[Taille_Ip_En_Cours] == 14) && (PacketReponse.Datagramme[Taille_Ip_En_Cours + 1] == 0)
							&& (Icmp_Id ==Icmp_Id_Retour) && (Icmp_Seq ==Icmp_Seq_Retour)) {
							/* Ip */
							Reponse->TaillePacketReponse = Taille_Trame;
							Reponse->HeaderLengthIP = Taille_Ip_En_Cours;
							Reponse->DSF = PacketReponse.Datagramme[1];
							memcpy (&Reponse->TailleTotal, &PacketReponse.Datagramme[2], 2);
							Reponse->TailleTotal = htons (Reponse->TailleTotal);
							memcpy (&Id_Ip_Retour, &PacketReponse.Datagramme[4], 2);
							Id_Ip_Retour = htons (Id_Ip_Retour);
							if (Id_Ip_Retour==0)
								Reponse->Id = 0;
							else
								Reponse->Id = 1;
							memcpy (&Reponse->Flags_IP_Offset, &PacketReponse.Datagramme[6], 2);
							Reponse->Flags_IP_Offset = htons (Reponse->Flags_IP_Offset);
							Reponse->TTL = PacketReponse.Datagramme[8];
							Fin = TRUE;	// boolean
						}
					}
				}
			}
		}
		time (&temps);
		tm = localtime (&temps);
		seconde_Actuelle = tm->tm_sec;
		if (seconde_Actuelle != seconde_Next) {
			seconde_Ecoule++;
			seconde_Next = seconde_Actuelle;
			// Renvoye la trame Syn au bout de 3,6,9,12 secondes 
			if ((seconde_Ecoule == 3) || (seconde_Ecoule == 6) || (seconde_Ecoule == 9) || (seconde_Ecoule == 12) || (seconde_Ecoule == 18)) {
				Id_Ip++;
				Packet_Icmp_Timestamp.Datagramme[4] = (Id_Ip >> 8) & 0xFF;
				Packet_Icmp_Timestamp.Datagramme[5] = Id_Ip & 0xFF;
				CheckSum_Calc = 0;
				memcpy (&Packet_Icmp_Timestamp.Datagramme[10], &CheckSum_Calc, 2);
				CheckSum_Calc = htons (ckecksum (&Packet_Icmp_Timestamp.Datagramme[0], 20,0));
				memcpy (&Packet_Icmp_Timestamp.Datagramme[10], &CheckSum_Calc, 2);
				if ((sendto (Socket, &Packet_Icmp_Timestamp, 54, 0, &sock, sizeof (sock))) < 0) {
					perror ("[S] Erreur : Envoie packet (ICMP Timestamp)");
					exit (-1);
				}
				printf ("[S][%d]  a  %d seconde  Nouvelle tentative Signature (ICMP Timestamp)\n", Machine,  seconde_Ecoule);
			}
			if (seconde_Ecoule == 21) {
				Fin = TRUE;	// boolean
			}
		}
	}
	close (Socket);
}



void Nouvelle_Requete_Ping (struct struct_Reponse *Reponse, int Machine, char *Icmp_Ping)
{
	struct sockaddr sock;
	int       Socket, Taille_Trame;
	unsigned short Id_Ip, Icmp_Id, Icmp_Seq, Icmp_Id_Retour, Icmp_Seq_Retour,Id_Ip_Retour;
	struct struct_trame Packet_Icmp_Ping, PacketReponse;
	unsigned short CheckSum_Calc;
	unsigned int Taille_Ip_En_Cours, Taille_Datagramme_IP_En_Cours;
	int       seconde_Debut, seconde_Ecoule, seconde_Actuelle, seconde_Next;
	int       Etat;
	gboolean  Fin;
	time_t    temps;
	struct tm *tm;

	usleep (300);
	bzero (Reponse, sizeof (struct struct_Reponse));
	Id_Ip = (unsigned short) random ();
	Icmp_Id = (unsigned short) random ();
	Icmp_Seq = 1;
	strcpy (sock.sa_data, Interface);
	sock.sa_family = AF_INET;
	if ((Socket = socket (AF_INET, SOCK_PACKET, htons (ETH_P_ALL))) < 0) {
		perror ("[S] Socket: ");
		exit (1);
	}
	set_NonBlock (Socket);
	memcpy (&Packet_Icmp_Ping.Dest_MAC, &Liste_Machines[Machine].AdresseMAC, ETH_ALEN);
	memcpy (&Packet_Icmp_Ping.Source_MAC, MonAdresseMac, ETH_ALEN);
	Packet_Icmp_Ping.Proto = htons (TRAME_IP);
	memcpy (&Packet_Icmp_Ping.Datagramme, Icmp_Ping, 59);
	memcpy (&Packet_Icmp_Ping.Datagramme[12], &MonAdresseIp, IP_ADDR_LEN);
	memcpy (&Packet_Icmp_Ping.Datagramme[16], &Liste_Machines[Machine].AdresseIp, IP_ADDR_LEN);
	CheckSum_Calc = htons (ckecksum (&Packet_Icmp_Ping.Datagramme[0], 20, 0));
	memcpy (&Packet_Icmp_Ping.Datagramme[10], &CheckSum_Calc, 2);
	Packet_Icmp_Ping.Datagramme[24] = (Icmp_Id >> 8) & 0xFF;
	Packet_Icmp_Ping.Datagramme[25] = Icmp_Id & 0xFF;	
	Packet_Icmp_Ping.Datagramme[26] = (Icmp_Seq >> 8) & 0xFF;
	Packet_Icmp_Ping.Datagramme[27] = Icmp_Seq & 0xFF;
	CheckSum_Calc = ckecksum (&Packet_Icmp_Ping.Datagramme[20], 39, 0);	//taille + protocole
	CheckSum_Calc = htons (CheckSum_Calc);
	memcpy (&Packet_Icmp_Ping.Datagramme[22], &CheckSum_Calc, 2);
	if ((sendto (Socket, &Packet_Icmp_Ping, 73, 0, &sock, sizeof (sock))) < 0) {
		perror ("[S] Erreur : Envoie packet Icmp_Timestamp");
		exit (-1);
	}
		
	time (&temps);
	tm = localtime (&temps);
	seconde_Debut = tm->tm_sec;
	seconde_Next = seconde_Debut;
	seconde_Ecoule = 0;
	Fin = FALSE;		// boolean
	while (!Fin) {		// boolean
		if (waiting_donnee (Socket, 1000)) {
			Taille_Trame = recvfrom (Socket, &PacketReponse, sizeof (struct struct_trame), 0, NULL, 0);
			if ((memcmp (PacketReponse.Source_MAC, Liste_Machines[Machine].AdresseMAC, ETH_ALEN) == 0)
				&& (memcmp (PacketReponse.Dest_MAC, MonAdresseMac, ETH_ALEN) == 0)) {
				if ((htons (PacketReponse.Proto) == TRAME_IP) && ((PacketReponse.Datagramme[0] >> 4) == IP_VERSION4) && (PacketReponse.Datagramme[9] == ICMP)) {
					if ((memcmp (&PacketReponse.Datagramme[16], &MonAdresseIp, IP_ADDR_LEN) == 0)
						&& (memcmp (&PacketReponse.Datagramme[12], &Liste_Machines[Machine].AdresseIp, IP_ADDR_LEN) == 0)) {
						Taille_Ip_En_Cours = (PacketReponse.Datagramme[0] & 0x0F) << 2;
						Taille_Datagramme_IP_En_Cours = (PacketReponse.Datagramme[2] << 8) + PacketReponse.Datagramme[3];
						printf ("Trame Ping recupere   %d  %d \n", PacketReponse.Datagramme[Taille_Ip_En_Cours], PacketReponse.Datagramme[Taille_Ip_En_Cours+1]);
						memcpy (&Icmp_Id_Retour, &PacketReponse.Datagramme[Taille_Ip_En_Cours + 4], 2);
						Icmp_Id_Retour = htons (Icmp_Id_Retour);
						memcpy (&Icmp_Seq_Retour, &PacketReponse.Datagramme[Taille_Ip_En_Cours + 6], 2);
						Icmp_Seq_Retour = htons (Icmp_Seq_Retour);
						printf("ICMP Ping  %04X=%04X   %04X=%04X\n",Icmp_Id_Retour,Icmp_Id,Icmp_Seq_Retour,Icmp_Seq);
						if ((PacketReponse.Datagramme[Taille_Ip_En_Cours] == 0) && (PacketReponse.Datagramme[Taille_Ip_En_Cours + 1] == 0)
							&& (Icmp_Id ==Icmp_Id_Retour) && (Icmp_Seq ==Icmp_Seq_Retour)) {
							/* Ip */
							Reponse->TaillePacketReponse = Taille_Trame;
							Reponse->HeaderLengthIP = Taille_Ip_En_Cours;
							Reponse->DSF = PacketReponse.Datagramme[1];
							memcpy (&Reponse->TailleTotal, &PacketReponse.Datagramme[2], 2);
							Reponse->TailleTotal = htons (Reponse->TailleTotal);
							memcpy (&Id_Ip_Retour, &PacketReponse.Datagramme[4], 2);
							Id_Ip_Retour = htons (Id_Ip_Retour);
							if (Id_Ip_Retour==0)
								Reponse->Id = 0;
							else
								Reponse->Id = 1;
							memcpy (&Reponse->Flags_IP_Offset, &PacketReponse.Datagramme[6], 2);
							Reponse->Flags_IP_Offset = htons (Reponse->Flags_IP_Offset);
							Reponse->TTL = PacketReponse.Datagramme[8];
							Fin = TRUE;	// boolean
						}
					}
				}
			}
		}
		time (&temps);
		tm = localtime (&temps);
		seconde_Actuelle = tm->tm_sec;
		if (seconde_Actuelle != seconde_Next) {
			seconde_Ecoule++;
			seconde_Next = seconde_Actuelle;
			// Renvoye la trame Syn au bout de 3,6,9,12 secondes 
			if ((seconde_Ecoule == 3) || (seconde_Ecoule == 6) || (seconde_Ecoule == 9) || (seconde_Ecoule == 12) || (seconde_Ecoule == 18)) {
				Id_Ip++;
				Packet_Icmp_Ping.Datagramme[4] = (Id_Ip >> 8) & 0xFF;
				Packet_Icmp_Ping.Datagramme[5] = Id_Ip & 0xFF;
				CheckSum_Calc = 0;
				memcpy (&Packet_Icmp_Ping.Datagramme[10], &CheckSum_Calc, 2);
				CheckSum_Calc = htons (ckecksum (&Packet_Icmp_Ping.Datagramme[0], 20,0));
				memcpy (&Packet_Icmp_Ping.Datagramme[10], &CheckSum_Calc, 2);
				if ((sendto (Socket, &Packet_Icmp_Ping, 73, 0, &sock, sizeof (sock))) < 0) {
					perror ("[S] Erreur : Envoie packet (ICMP Ping)");
					exit (-1);
				}
				printf ("[S][%d]  a  %d seconde  Nouvelle tentative Signature (ICMP Ping)\n", Machine,  seconde_Ecoule);
			}
			if (seconde_Ecoule == 21) {
				Fin = TRUE;	// boolean
			}
		}
	}
	close (Socket);
}
