/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <time.h>
#include "Reseau.h"
#include "OS_Detect.h"


void Nouvelle_Requete_UDP (struct struct_Reponse *Reponse, int Machine, int Port_Client, char *Udp)
{
	struct sockaddr sock;
	int       Socket, Taille_Trame;
	unsigned short Id_Ip, Port, Port_Destination_UDP, Port_Source_UDP, Id_Ip_UDP,Id_Ip_Retour;
	struct struct_trame PacketUDP, PacketReponse;
	unsigned short CheckSum_Calc;
	int       seconde_Debut, seconde_Ecoule, seconde_Actuelle, seconde_Next;
	int       Etat;
	gboolean  Fin;
	time_t    temps;
	struct tm *tm;
	unsigned int Taille_Ip_En_Cours, Taille_Datagramme_IP_En_Cours;


	usleep (300);
	bzero (Reponse, sizeof (struct struct_Reponse));
	Id_Ip = (unsigned short) random ();
	Port = ((unsigned short) random ());
	Port = (Port & 0x0FFF) + 0xF000;
	strcpy (sock.sa_data, Interface);
	sock.sa_family = AF_INET;
	if ((Socket = socket (AF_INET, SOCK_PACKET, htons (ETH_P_ALL))) < 0) {
		perror ("[S] Socket: ");
		exit (1);
	}
	set_NonBlock (Socket);
	memcpy (&PacketUDP.Dest_MAC, &Liste_Machines[Machine].AdresseMAC, ETH_ALEN);
	memcpy (&PacketUDP.Source_MAC, MonAdresseMac, ETH_ALEN);
	PacketUDP.Proto = htons (TRAME_IP);
	memcpy (&PacketUDP.Datagramme, Udp, 58);
	PacketUDP.Datagramme[4] = (Id_Ip >> 8) & 0xFF;
	PacketUDP.Datagramme[5] = Id_Ip & 0xFF;
	memcpy (&PacketUDP.Datagramme[12], &MonAdresseIp, IP_ADDR_LEN);
	memcpy (&PacketUDP.Datagramme[16], &Liste_Machines[Machine].AdresseIp, IP_ADDR_LEN);
	CheckSum_Calc = htons (ckecksum (&PacketUDP.Datagramme[0], 20, 0));
	memcpy (&PacketUDP.Datagramme[10], &CheckSum_Calc, 2);
	PacketUDP.Datagramme[20] = (Port >> 8) & 0xFF;
	PacketUDP.Datagramme[21] = Port & 0xFF;
	PacketUDP.Datagramme[22] = (Port_Client >> 8) & 0xFF;
	PacketUDP.Datagramme[23] = Port_Client & 0xFF;
	CheckSum_Calc = ckecksum (&PacketUDP.Datagramme[12], 46, 38 + 17);	//taille + protocole
	CheckSum_Calc = htons (CheckSum_Calc);
	memcpy (&PacketUDP.Datagramme[26], &CheckSum_Calc, 2);
	if ((sendto (Socket, &PacketUDP, 72, 0, &sock, sizeof (sock))) < 0) {
		perror ("[S] Erreur : Envoie packet UDP ");
		exit (-1);
	}

	time (&temps);
	tm = localtime (&temps);
	seconde_Debut = tm->tm_sec;
	seconde_Next = seconde_Debut;
	seconde_Ecoule = 0;
	Fin = FALSE;		// boolean
	while (!Fin) {		// boolean
		if (waiting_donnee (Socket, 1000)) {
			Taille_Trame = recvfrom (Socket, &PacketReponse, sizeof (struct struct_trame), 0, NULL, 0);
			if ((memcmp (PacketReponse.Source_MAC, Liste_Machines[Machine].AdresseMAC, ETH_ALEN) == 0)
				&& (memcmp (PacketReponse.Dest_MAC, MonAdresseMac, ETH_ALEN) == 0)) {
				if ((htons (PacketReponse.Proto) == TRAME_IP) && ((PacketReponse.Datagramme[0] >> 4) == IP_VERSION4) && (PacketReponse.Datagramme[9] == ICMP)) {
					if ((memcmp (&PacketReponse.Datagramme[16], &MonAdresseIp, IP_ADDR_LEN) == 0)
						&& (memcmp (&PacketReponse.Datagramme[12], &Liste_Machines[Machine].AdresseIp, IP_ADDR_LEN) == 0)) {
						Taille_Ip_En_Cours = (PacketReponse.Datagramme[0] & 0x0F) << 2;
						Taille_Datagramme_IP_En_Cours = (PacketReponse.Datagramme[2] << 8) + PacketReponse.Datagramme[3];
						printf ("Trame ICMP recupere   %d  %d \n", PacketReponse.Datagramme[Taille_Ip_En_Cours], PacketReponse.Datagramme[Taille_Ip_En_Cours + 1]);
						memcpy (&Id_Ip_UDP, &PacketReponse.Datagramme[Taille_Ip_En_Cours + 12], 2);
						Id_Ip_UDP = htons (Id_Ip_UDP);
						memcpy (&Port_Source_UDP, &PacketReponse.Datagramme[Taille_Ip_En_Cours + 28], 2);
						Port_Source_UDP = htons (Port_Source_UDP);
						memcpy (&Port_Destination_UDP, &PacketReponse.Datagramme[Taille_Ip_En_Cours + 30], 2);
						Port_Destination_UDP = htons (Port_Destination_UDP);
						printf ("ICMP   %04X   %04X    %04X\n", Id_Ip_UDP, Port_Source_UDP, Port_Destination_UDP);
						if ((PacketReponse.Datagramme[Taille_Ip_En_Cours] == 3) && (PacketReponse.Datagramme[Taille_Ip_En_Cours + 1] == 3)
							&& (Id_Ip == Id_Ip_UDP) && (Port == Port_Source_UDP) && (Port_Destination_UDP == Port_Client)) {
							/* Ip */
							Reponse->TaillePacketReponse = Taille_Trame;
							Reponse->HeaderLengthIP = Taille_Ip_En_Cours;
							Reponse->DSF = PacketReponse.Datagramme[1];
							memcpy (&Reponse->TailleTotal, &PacketReponse.Datagramme[2], 2);
							Reponse->TailleTotal = htons (Reponse->TailleTotal);
							memcpy (&Id_Ip_Retour, &PacketReponse.Datagramme[4], 2);
							Id_Ip_Retour = htons (Id_Ip_Retour);
							if (Id_Ip_Retour==0)
								Reponse->Id = 0;
							else
								Reponse->Id = 1;
							memcpy (&Reponse->Flags_IP_Offset, &PacketReponse.Datagramme[6], 2);
							Reponse->Flags_IP_Offset = htons (Reponse->Flags_IP_Offset);
							Reponse->TTL = PacketReponse.Datagramme[8];
							Fin = TRUE;	// boolean
						}
					}
				}
			}
		}
		time (&temps);
		tm = localtime (&temps);
		seconde_Actuelle = tm->tm_sec;
		if (seconde_Actuelle != seconde_Next) {
			seconde_Ecoule++;
			seconde_Next = seconde_Actuelle;
			// Renvoye la trame Syn au bout de 3,6,9,12 secondes 
			if ((seconde_Ecoule == 3) || (seconde_Ecoule == 6) || (seconde_Ecoule == 9) || (seconde_Ecoule == 12) || (seconde_Ecoule == 18)) {
				Id_Ip++;
				PacketUDP.Datagramme[4] = (Id_Ip >> 8) & 0xFF;
				PacketUDP.Datagramme[5] = Id_Ip & 0xFF;
				CheckSum_Calc = 0;
				memcpy (&PacketUDP.Datagramme[10], &CheckSum_Calc, 2);
				CheckSum_Calc = htons (ckecksum (&PacketUDP.Datagramme[0], 20,0));
				memcpy (&PacketUDP.Datagramme[10], &CheckSum_Calc, 2);
				if ((sendto (Socket, &PacketUDP, 72, 0, &sock, sizeof (sock))) < 0) {
					perror ("[S] Erreur : Envoie packet UDP");
					exit (-1);
				}
				printf ("[S][%d]   (%d)->(%d) a  %d seconde  Nouvelle tentative Signature (UDP)\n", Machine, Port, Port_Client, seconde_Ecoule);
			}
			if (seconde_Ecoule == 21) {
				Fin = TRUE;	// boolean
			}
		}
	}
	close (Socket);
}
