/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Port.h"
#include "Declaration.h"
extern int h_errno;


void Ajoute_Nouveau_Port (char *buf, int Emplacement)
{
	char     *pBuf;
	int       Taille;

	if (sscanf (buf, "%d;%d;",&Liste_Port_Scan[Emplacement].Num_Port, &Liste_Port_Scan[Emplacement].Type_Machine) != 2) {
		printf ("[S] Erreur de lecture du fichier PortListe\n");
		exit (0);
	}
}

 

void Creer_PortList ()
{
	FILE     *Fichier_PortList;
	char      buf[512],CheminFichier[256];


	printf ("[S] Creation de la liste des ports\n");
	sprintf (CheminFichier, "%s/Conf/Port", pwd_Utilisateur);
	if ((Fichier_PortList = fopen (CheminFichier, "r")) == NULL) {
		perror ("[S] fopen :");
		printf ("[S] Impossible de lire PortListe\n");
		exit (-1);
	}
	Nb_Port_Dans_Liste_Scan = 0;
	while (fgets (buf, sizeof (buf), Fichier_PortList))
		Nb_Port_Dans_Liste_Scan++;
	rewind (Fichier_PortList);
	Liste_Port_Scan = (struct struct_Liste_Port *) malloc (sizeof (struct struct_Liste_Port) * (Nb_Port_Dans_Liste_Scan + 1));
	Nb_Port_Dans_Liste_Scan = 0;

	while (fgets (buf, sizeof (buf), Fichier_PortList)) {
		Ajoute_Nouveau_Port (buf, Nb_Port_Dans_Liste_Scan);
		Nb_Port_Dans_Liste_Scan++;
	}
	Liste_Port_Scan[Nb_Port_Dans_Liste_Scan].Num_Port = FIN_LISTE_PORT;	//FIN
	printf ("[S] Creation de la liste des ports (%d ports trouves)\n", Nb_Port_Dans_Liste_Scan);
	fclose (Fichier_PortList);
}
