/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "Reseau.h"
#include "Declaration.h"
#include "Sous_Reseau.h"


char      Refresh_Arp[] = { 0x00, 0x01, 0x08, 0x00, 0x06, 0x04, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

void Refresh (int NumMachine)
{
	int       Socket, Taille_Trame, i, j;
	struct sockaddr sock;
	struct struct_trame PacketScanReseau;
	struct struct_Message_Temps_Reel Message_Temps_Reel;


	printf ("[S] Changement etat Machine [%d] = Arret refresh\n", NumMachine);
	Liste_Machines[NumMachine].Machine_Allumer = FALSE;
	Message_Temps_Reel.type = 1;
	Message_Temps_Reel.type_message = ARRET_MACHINE;
	memcpy (Message_Temps_Reel.Mac_Adresse_Machine, &Liste_Machines[NumMachine].AdresseMAC, 6);
	if (msgsnd (File_Envoie_Message_Temps_Reel, (void *) &Message_Temps_Reel, sizeof (Message_Temps_Reel) - sizeof (long), 0) < 0) {
		perror ("[S] msgsnd");
		exit (1);
	}
	
	strcpy (sock.sa_data, Interface);
	sock.sa_family = AF_INET;
	if ((Socket = socket (AF_INET, SOCK_PACKET, htons (ETH_P_ALL))) < 0) {
		perror ("Socket: ");
		exit (1);
	}
	for (j = 0; j < ETH_ALEN; j++)
		PacketScanReseau.Dest_MAC[j] = 255;
	memcpy (&PacketScanReseau.Source_MAC, &MonAdresseMac, ETH_ALEN);
	PacketScanReseau.Proto = htons (TRAME_ARP);
	memcpy (&PacketScanReseau.Datagramme, Refresh_Arp, sizeof (Refresh_Arp));
	memcpy (&PacketScanReseau.Datagramme[8], MonAdresseMac, ETH_ALEN);
	memcpy (&PacketScanReseau.Datagramme[14], &MonAdresseIp, IP_ADDR_LEN);
	memcpy (&PacketScanReseau.Datagramme[24], &Liste_Machines[NumMachine].AdresseIp, IP_ADDR_LEN);

	if ((sendto (Socket, &PacketScanReseau, 42, 0, &sock, sizeof (sock))) < 0) {
		perror ("[S] Erreur : Envoie packet Refresh");
		exit (-1);
	}
	usleep (40000);		// 40 millisecondes
	if ((sendto (Socket, &PacketScanReseau, 42, 0, &sock, sizeof (sock))) < 0) {
		perror ("[S] Erreur : Envoie packet Refresh");
		exit (-1);
	}

	close (Socket);
}
