/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "Reseau.h"
#include "Declaration.h"
#include "Sous_Reseau.h"


char      Scan[] = { 0x00, 0x01, 0x08, 0x00, 0x06, 0x04, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,	0x00, 0x00, 0x00, 0x00 };

void Initialise_Structure_Sous_Reseau ()
{
	int       i;

	for (i = 0; i < MAX_SOUS_RESEAU; i++) {
		Sous_Reseau[i].Reseau[0] = 0;
		Sous_Reseau[i].Deja_Scanner = FALSE;// boolean
	}
}




void     *Nouveau_Sous_Reseau (int NumSousReseau)
{
	int       Socket, Taille_Trame, i, j;
	struct sockaddr sock;
	struct struct_trame PacketScanReseau;
	unsigned char Mask_Reseau[IP_ADDR_LEN - 1];

	if (Autoriser_Scan == TRUE) { // boolean
		Sous_Reseau[NumSousReseau].Deja_Scanner = TRUE; // boolean
		sleep (1);
		memcpy (&Mask_Reseau, &Sous_Reseau[NumSousReseau].Reseau, sizeof (Mask_Reseau));
		printf ("[S] Nouveau sous reseau : %d.%d.%d.255     pid:[%d]\n", Mask_Reseau[0], Mask_Reseau[1], Mask_Reseau[2], getpid ());
		strcpy (sock.sa_data, Interface);
		sock.sa_family = AF_INET;
		if ((Socket = socket (AF_INET, SOCK_PACKET, htons (ETH_P_ALL))) < 0) {
			perror ("Socket: ");
			exit (1);
		}	
		for (i = 0; i < 256; i++) {
			for (j = 0; j < ETH_ALEN; j++)
				PacketScanReseau.Dest_MAC[j] = 255;
			memcpy (&PacketScanReseau.Source_MAC, &MonAdresseMac, ETH_ALEN);
			PacketScanReseau.Proto = htons (TRAME_ARP);
			memcpy (&PacketScanReseau.Datagramme, Scan, sizeof (Scan));
			memcpy (&PacketScanReseau.Datagramme[8], MonAdresseMac, ETH_ALEN);
			memcpy (&PacketScanReseau.Datagramme[14], &MonAdresseIp, IP_ADDR_LEN);
			memcpy (&PacketScanReseau.Datagramme[24], &Mask_Reseau, IP_ADDR_LEN - 1);
			PacketScanReseau.Datagramme[27] = (unsigned char) i;
			if ((sendto (Socket, &PacketScanReseau, 42, 0, &sock, sizeof (sock))) < 0) {
				perror ("[S] Erreur : Envoie packet PacketScanReseau");
				exit (-1);
			}		
			usleep (40000); // 40 millisecondes
			if ((sendto (Socket, &PacketScanReseau, 42, 0, &sock, sizeof (sock))) < 0) {
				perror ("[S] Erreur : Envoie packet PacketScanReseau");
				exit (-1);
			}	
			usleep (40000); // 40 millisecondes
		}
		close (Socket);
		printf ("[S] FIN SCAN SOUS RESEAU\n");
	}

	pthread_exit (NULL);
}
