/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Reseau.h"
#include "callbacks.h"
#include "Machine.h"
#include <dirent.h>

int       Icone_Demarrage_Selectionner;
void Affiche_Liste_Reseau ();

void on_window_demarrage_destroy (GtkObject * object, gpointer user_data)
{
	window_demarrage = create_window_demarrage ();
	printf ("[I] Re-creation\n");
	IconeSelectionner_Nouveau = 0;
	Affiche_Liste_Reseau ();
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Demarrage_Ajouter), TRUE);
}



void on_iconlist_Demarrage_Fichier_select_icon (GnomeIconList * iconlist, gint num, GdkEvent * event, gpointer user_data)
{
	printf ("[I] Icone Selectionner : %d\n", num);
	Icone_Demarrage_Selectionner = num;
}


void on_button_Demarrage_Annuler_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_hide (window_demarrage);
}


void on_button_Demarrage_Valider_clicked (GtkButton * button, gpointer user_data)
{
	struct struct_Demande Demande_Demarrage_Scan;
	DIR      *dir;
	int       i;
	struct dirent *entree;
	struct stat status;
	char      Chemin_AutoScan[255], chemin[255];


	if (Icone_Demarrage_Selectionner != -1) {
		gtk_widget_hide (window_demarrage);
		Demarrage = FALSE;
		Root_Afficher = TRUE;
		gtk_widget_show (window);
		/* Restauration */
		if (Icone_Demarrage_Selectionner != 0) {
			sprintf (Chemin_AutoScan, "%s/.AutoScan/Network", Info_User->pw_dir);
			printf ("[I] Chemin : [%s]\n", Chemin_AutoScan);
			dir = opendir (Chemin_AutoScan);
			if (dir == NULL) {
				printf ("[I] Rpertoire introuvable ou pas assez de permissions\n");
				exit (-1);
			}
			i = 0;
			while ((i != Icone_Demarrage_Selectionner) && ((entree = readdir (dir)) != NULL)) {
				sprintf (chemin, "%s/%s", Chemin_AutoScan, entree->d_name);
				stat (chemin, &status);
				if (S_ISREG (status.st_mode)) {
					i++;
				}
			}
			printf ("[I] Fichier Selectionnee : [%s]\n", entree->d_name);
			if (!Restauration (chemin)) {
				printf("[I] Restauration Erreur\n");
				Fin (ARRET);
			}
		}

		/* Doit on ajouter les nouvelles machines trouves */
		if ((Icone_Demarrage_Selectionner == 0) || (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Demarrage_Ajouter)))) {
			Demande_Demarrage_Scan.type = 1;
			Demande_Demarrage_Scan.type_demande = DEMARRAGE_SCAN;
			sprintf (Chemin_AutoScan, "%s/.AutoScan/", Info_User->pw_dir);
			strcpy (Demande_Demarrage_Scan.donnee, Chemin_AutoScan);
			strcpy (Demande_Demarrage_Scan.interface, gtk_entry_get_text (GTK_ENTRY (combo_entry_Preference_Interface)));
			Demande_Demarrage_Scan.Nb_Thread_Max = (int) gtk_adjustment_get_value (GTK_ADJUSTMENT (spinbutton_Preference_Interface_Max_Thread_Scan_adj));
			if (msgsnd (File_Envoie_Demande, (void *) &Demande_Demarrage_Scan, sizeof (Demande_Demarrage_Scan) - sizeof (long), 0) < 0) {
				perror ("[I] msgsnd");
				exit (1);
			}
		}
		if (!gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Demarrage_Ajouter))) {
			Demande_Demarrage_Scan.type = 1;
			Demande_Demarrage_Scan.type_demande = DEMARRAGE_SANS_SCAN;
			sprintf (Chemin_AutoScan, "%s/.AutoScan/", Info_User->pw_dir);
			strcpy (Demande_Demarrage_Scan.donnee, Chemin_AutoScan);
			strcpy (Demande_Demarrage_Scan.interface, gtk_entry_get_text (GTK_ENTRY (combo_entry_Preference_Interface)));
			Demande_Demarrage_Scan.Nb_Thread_Max = (int) gtk_adjustment_get_value (GTK_ADJUSTMENT (spinbutton_Preference_Interface_Max_Thread_Scan_adj));
			if (msgsnd (File_Envoie_Demande, (void *) &Demande_Demarrage_Scan, sizeof (Demande_Demarrage_Scan) - sizeof (long), 0) < 0) {
				perror ("[I] msgsnd");
				exit (1);
			}
		}
	}

}


void Copie_Fichier_Configuration ()
{
	DIR      *dir;
	struct dirent *entree;
	struct stat status;
	char      Chemin_AutoScan[255], chemin[255], Fichier[255];

	/* Ouverture ou cration du rpertoire .AutoScan */
	sprintf (Chemin_AutoScan, "%s/.AutoScan", Info_User->pw_dir);
	printf ("[I] Chemin : [%s]\n", Chemin_AutoScan);
	dir = opendir (Chemin_AutoScan);
	if (dir == NULL) {
		/* Creation du repertoire ~/.AutoScan */
		if (mkdir (Chemin_AutoScan, 0700) != 0) {
			perror ("");
			exit (1);
		}
		dir = opendir (Chemin_AutoScan);
		if (dir == NULL) {
			printf ("[I] Rpertoire introuvable ou pas assez de permissions  (~/.AutoScan)\n");
			exit (-1);
		}
	}
	closedir (dir);

	/* Ouverture ou cration du rpertoire .AutoScan/Conf */
	sprintf (Chemin_AutoScan, "%s/.AutoScan/Conf", Info_User->pw_dir);
	printf ("[I] Chemin : [%s]\n", Chemin_AutoScan);
	dir = opendir (Chemin_AutoScan);
	if (dir == NULL) {
		/* Creation du repertoire ~/.AutoScan/Conf */
		if (mkdir (Chemin_AutoScan, 0700) != 0) {
			perror ("");
			exit (1);
		}
		dir = opendir (Chemin_AutoScan);
		if (dir == NULL) {
			printf ("[I] Rpertoire introuvable ou pas assez de permissions (~/.AutoScan/Network)\n");
			exit (-1);
		}
		printf ("[I] Copie Fichier : FingerPrinting\n");
		sprintf (Fichier, "%s/FingerPrinting", Chemin_AutoScan);
		if (Copie_Fichier ("/usr/share/apps/AutoScan/FingerPrinting", Fichier) == FALSE)
			exit (-1);
		printf ("[I] Copie Fichier : Mac\n");
		sprintf (Fichier, "%s/Mac", Chemin_AutoScan);
		if (Copie_Fichier ("/usr/share/apps/AutoScan/Mac", Fichier) == FALSE)
			exit (-1);
		printf ("[I] Copie Fichier : Port\n");
		sprintf (Fichier, "%s/Port", Chemin_AutoScan);
		if (Copie_Fichier ("/usr/share/apps/AutoScan/Port", Fichier) == FALSE)
			exit (-1);
		printf ("[I] Copie Fichier : Script\n");
		sprintf (Fichier, "%s/Script", Chemin_AutoScan);
		if (Copie_Fichier ("/usr/share/apps/AutoScan/Script", Fichier) == FALSE)
			exit (-1);
		printf ("[I] Copie Fichier : SubNet\n");
		sprintf (Fichier, "%s/SubNet", Chemin_AutoScan);
		if (Copie_Fichier ("/usr/share/apps/AutoScan/SubNet", Fichier) == FALSE)
			exit (-1);
	}
	closedir (dir);
}


void Affiche_Liste_Reseau ()
{
	DIR      *dir;
	struct dirent *entree;
	struct stat status;
	char      Chemin_AutoScan[255], chemin[255], Fichier[255];
	int       Nombre_Reseau;
	FILE     *fnotify = NULL;

	Icone_Demarrage_Selectionner = -1;
	Nombre_Reseau = 0;
	gnome_icon_list_clear (GNOME_ICON_LIST (iconlist_Demarrage_Fichier));
	gnome_icon_list_freeze (GNOME_ICON_LIST (iconlist_Demarrage_Fichier));
	gnome_icon_list_append (GNOME_ICON_LIST (iconlist_Demarrage_Fichier), "/usr/share/pixmaps/AutoScan/unknown.png", "New network");
/* Ouverture ou cration du rpertoire .AutoScan/Network */
	sprintf (Chemin_AutoScan, "%s/.AutoScan/Network", Info_User->pw_dir);
	printf ("[I] Chemin : [%s]\n", Chemin_AutoScan);
	dir = opendir (Chemin_AutoScan);
	if (dir == NULL) {
		/* Creation du repertoire ~/.AutoScan/Network */
		if (mkdir (Chemin_AutoScan, 0700) != 0) {
			perror ("");
			exit (1);
		}
		dir = opendir (Chemin_AutoScan);
		if (dir == NULL) {
			printf ("[I] Rpertoire introuvable ou pas assez de permissions (~/.AutoScan/Network)\n");
			exit (-1);
		}
		/*printf ("[I] Copie Fichier : Example\n");
		sprintf (Fichier, "%s/Example", Chemin_AutoScan);
		if (Copie_Fichier ("/usr/share/apps/AutoScan/Example", Fichier) == FALSE)
			exit (-1);*/
		Initialisation_Preference ();
		futur_version ();
		gtk_widget_show (window_demarrage);
		gtk_widget_show (window_Preference);
	}
	else {
		sprintf (Fichier, "%s/.AutoScan/Conf/Notify", Info_User->pw_dir);
		if ((fnotify = fopen (Fichier, "r")) == NULL) {
			printf ("[I] Ne peut pas lire [%s]\n", Fichier);
			window_Notification = create_window_Notification ();
			gtk_widget_show (window_Notification);
		}
		else {
			fclose (fnotify);
		}
	}

	while ((entree = readdir (dir)) != NULL) {
		sprintf (chemin, "%s/%s", Chemin_AutoScan, entree->d_name);
		printf ("[I] %s\n", entree->d_name);
		stat (chemin, &status);
		if (S_ISREG (status.st_mode)) {
			printf ("[I] Fichier : [%s]\n", entree->d_name);
			gnome_icon_list_append (GNOME_ICON_LIST (iconlist_Demarrage_Fichier), "/usr/share/pixmaps/AutoScan/network_local.png", entree->d_name);
			Nombre_Reseau++;
		}
	}

	if (Nombre_Reseau == 0) {
		printf ("[I] Attention : Aucun fichier dans Network/\n");
		//exit (-1);
	}
	gnome_icon_list_thaw (GNOME_ICON_LIST (iconlist_Demarrage_Fichier));
	closedir (dir);
	/*if (Nombre_Reseau == 0) {
		Affiche_Liste_Reseau ();
	}*/
}



void on_button_Notifications_Fermer_clicked (GtkButton * button, gpointer user_data)
{
	char      Fichier[255];
	FILE     *fnotify = NULL;


	gtk_widget_hide (window_Notification);
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Notifications))) {
		sprintf (Fichier, "%s/.AutoScan/Conf/Notify", Info_User->pw_dir);
		if ((fnotify = fopen (Fichier, "w")) == NULL) {
			printf ("[I] Ne peut pas creer [%s]\n", Fichier);
		}
		else
			fclose (fnotify);
	}
}
