/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Reseau.h"
extern int h_errno;

char     *Execute_Retour (char *Command)
{
	int       tube[2], pid_fils, Taille_Lu, Taille_Buffer, Taille_Total_Buffer, Taille_Lu_Total;
	char     *buffer;

	if (pipe (tube) == -1) {
		perror ("[I] Erreur tube");
		exit (1);
	}
	pid_fils = fork ();	// création d'un fils
	if (pid_fils == 0) {
		/* Fils */
		dup2 (tube[1], 1);
		dup2 (tube[1], 2);
		fcntl (tube[0], F_SETFL, O_NDELAY);
		system (Command);
		exit (127);
	}
	set_NonBlock (tube[0]);
	Taille_Buffer = 100;
	buffer = (char *) malloc (sizeof (char) * Taille_Buffer + 1);
	Taille_Total_Buffer = Taille_Buffer;
	Taille_Lu_Total = 0;
	do {
		if (Taille_Lu_Total != 0) {
			Taille_Total_Buffer = Taille_Lu_Total + Taille_Buffer;
			printf ("[I] Taille Total : %d\n", Taille_Total_Buffer);
			if ((buffer = (char *) realloc (buffer, sizeof (char) * Taille_Total_Buffer)) == 0) {
				perror ("[I] Erreur realloc");
				exit (1);
			}
		}
		if (waiting_donnee (tube[0], 30000)) {
			Taille_Lu = read (tube[0], (buffer + Taille_Lu_Total), Taille_Buffer);
			if (Taille_Lu == -1) {
				perror ("[I] Read ");
				return NULL;
			}
			else {
				Taille_Lu_Total = Taille_Lu_Total + Taille_Lu;
			}
		}
		else {
			Taille_Lu = 0;	//                return NULL;
		}
	}
	while ((Taille_Lu == -1) || (Taille_Lu != 0));	//(Taille_Lu == Taille_Buffer));
	buffer[Taille_Lu_Total] = 0;
	printf ("[I] %d [%s]\n", strlen (buffer), buffer);
	return buffer;
}
