/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <gnome.h>

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)



/*

GNOME_MESSAGE_BOX_ERROR   GNOME_MESSAGE_BOX_WARNING   GNOME_MESSAGE_BOX_INFO
*/
void Message (char *Message, int type)
{
	GtkWidget *messagebox;
	GtkWidget *dialog_vbox;
	GtkWidget *dialog_action_area;
	GtkWidget *button_Message;

	messagebox = gnome_message_box_new (Message, type, NULL);
	gtk_window_set_title (GTK_WINDOW (messagebox), "Information");
	gtk_window_set_position (GTK_WINDOW (messagebox), GTK_WIN_POS_CENTER);
	gtk_window_set_resizable (GTK_WINDOW (messagebox), FALSE);

	dialog_vbox = GNOME_DIALOG (messagebox)->vbox;
	gtk_widget_show (dialog_vbox);

	dialog_action_area = GNOME_DIALOG (messagebox)->action_area;
	gtk_widget_show (dialog_action_area);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area), GTK_BUTTONBOX_SPREAD);

	gnome_dialog_append_button (GNOME_DIALOG (messagebox), "gtk-ok");
	button_Message = GTK_WIDGET (g_list_last (GNOME_DIALOG (messagebox)->buttons)->data);
	gtk_widget_show (button_Message);
	GTK_WIDGET_SET_FLAGS (button_Message, GTK_CAN_DEFAULT);

	/* Store pointers to all widgets, for use by lookup_widget(). */
	GLADE_HOOKUP_OBJECT_NO_REF (messagebox, messagebox, "messagebox");
	GLADE_HOOKUP_OBJECT_NO_REF (messagebox, dialog_vbox, "dialog_vbox");
	GLADE_HOOKUP_OBJECT_NO_REF (messagebox, dialog_action_area, "dialog_action_area");
	GLADE_HOOKUP_OBJECT (messagebox, button_Message, "button_Message");
	gtk_widget_show (messagebox);
}
