/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include "callbacks.h"

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>





enum {
	BMP_COLUMN,
	TEXT_COLUMN,
	POINTER,
	N_COLUMN
};

enum {
	TARGET_STRING,
	TARGET_URL
};

static GtkTargetEntry target_table[] = {
	{"STRING", 0, TARGET_STRING},
	{"text/plain", 0, TARGET_STRING},
	{"text/uri-list", 0, TARGET_URL}
};

static guint n_targets = sizeof (target_table) / sizeof (target_table[0]);



char      string[] = "file:/home/thierry/cube.xpm\r\0";



static void row_activated (GtkTreeView * tree_view, GtkTreePath * path, GtkTreeViewColumn * column, gpointer data)
{


	char     *fdata;
	GtkTreeIter iter;

	printf ("Click \n");
	if (!gtk_tree_model_get_iter (GTK_TREE_MODEL (pTreeStore), &iter, path))
		return;
	gtk_tree_model_get (GTK_TREE_MODEL (pTreeStore), &iter, TEXT_COLUMN, &fdata, -1);
	printf ("%s\n", fdata);

	gtk_tree_model_get (GTK_TREE_MODEL (pTreeStore), &iter, 2, &fdata, -1);
	printf ("%s\n", fdata);
	//gtk_tree_store_clear(pTreeStore);


}

static void drag_begin (GtkWidget * widget, GdkDragContext * context, gpointer data)
{
	printf ("drag_begin\n");

}




static void drag_end (GtkWidget * widget, GdkDragContext * context, gpointer data)
{
	printf ("drag_end\n");

}



void on_treeview1_drag_data_get (GtkTreeDragSource * drag_source, GtkTreePath * path, GtkSelectionData * data)
{

	gtk_selection_data_set (data, data->target, 8, string, sizeof (string));

	printf ("on_treeview1_drag_data_get\n");
	printf ("Got: %s\n", data->data);

}



void view_onDragDataReceived (GtkWidget * wgt, GdkDragContext * context, int x, int y, GtkSelectionData * seldata, guint info, guint time, gpointer userdata)
{
	GtkTreeModel *model;
	GtkTreeIter iter;
	GdkPixbuf *pPixBufA;

	printf ("[%s]\n", seldata->data);
	strcpy (string, seldata->data);
/*	model = GTK_TREE_MODEL (userdata);
	pPixBufA = gdk_pixbuf_new_from_file ("./ftp.png", NULL);

	// Creation de la nouvelle ligne 
	gtk_tree_store_append (pTreeStore, &iter, NULL);

	// Mise a jour des donnees 
	gtk_tree_store_set (pTreeStore, &iter, BMP_COLUMN, pPixBufA, TEXT_COLUMN, seldata->data, -1);

	g_object_unref (pPixBufA);*/
}




static GtkWidget *create_view_and_model (void)
{
	GtkTreeViewColumn *pColumn;
	GtkCellRenderer *pCellRenderer;
	GtkListStore *liststore;
	GtkWidget *view;
	gchar    *sTexte;
	GdkPixbuf *pPixBufA;
	GdkPixbuf *pPixBufB;
	gint      i;
	GtkWidget *pTreeView;
	GtkTreeSelection *selection;

	// Creation du modele 
	pTreeStore = gtk_list_store_new(N_COLUMN, GDK_TYPE_PIXBUF, G_TYPE_STRING,G_TYPE_POINTER);//gtk_tree_store_new (N_COLUMN, GDK_TYPE_PIXBUF, G_TYPE_STRING);

	/*sTexte = g_malloc (16);
	 * 
	 * //Chargement des images 
	 * pPixBufA = gdk_pixbuf_new_from_file ("./ftp.png", NULL);
	 * 
	 * // Insertion des elements 
	 * for (i = 0; i < 10; ++i) {
	 * GtkTreeIter pIter;
	 * GtkTreeIter pIter2;
	 * gint      j;
	 * 
	 * sprintf (sTexte, "Ordinateur %d", i);
	 * 
	 * // Creation de la nouvelle ligne 
	 * gtk_tree_store_append (pTreeStore, &pIter, NULL);
	 * 
	 * // Mise a jour des donnees 
	 * gtk_tree_store_set (pTreeStore, &pIter, BMP_COLUMN, pPixBufA, TEXT_COLUMN, sTexte, -1);
	 * 
	 * }
	 * 
	 * g_free (sTexte);
	 * 
	 * g_object_unref (pPixBufA); */

	// Creation de la vue 
	pTreeView = gtk_tree_view_new_with_model (GTK_TREE_MODEL (pTreeStore));
	selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (pTreeView));
	gtk_tree_selection_set_mode (selection, GTK_SELECTION_MULTIPLE);

	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (pTreeView), FALSE);
	//gtk_tree_view_set_enable_search (GTK_TREE_VIEW (pTreeView), TRUE);
	//gtk_tree_view_set_reorderable (GTK_TREE_VIEW (pTreeView), TRUE);
	// Creation de la premiere colonne 
	pCellRenderer = gtk_cell_renderer_pixbuf_new ();
	pColumn = gtk_tree_view_column_new_with_attributes ("Image", pCellRenderer, "pixbuf", BMP_COLUMN, NULL);

	// Ajout de la colonne à la vue 
	gtk_tree_view_append_column (GTK_TREE_VIEW (pTreeView), pColumn);

	// Creation de la deuxieme colonne 
	pCellRenderer = gtk_cell_renderer_text_new ();
	pColumn = gtk_tree_view_column_new_with_attributes ("Label", pCellRenderer, "text", TEXT_COLUMN, NULL);

	// Ajout de la colonne à la vue 
	gtk_tree_view_append_column (GTK_TREE_VIEW (pTreeView), pColumn);

	enum {
		TARGET_STRING,
		TARGET_URL
	};

	static GtkTargetEntry targetentries[] = {
		{"text/plain", 0, TARGET_STRING}
	};

	gtk_drag_dest_set (pTreeView, GTK_DEST_DEFAULT_ALL, targetentries, 1, GDK_ACTION_COPY | GDK_ACTION_MOVE | GDK_ACTION_LINK);
	g_signal_connect (pTreeView, "drag_data_received", G_CALLBACK (view_onDragDataReceived), NULL);


	//gtk_tree_view_enable_model_drag_source (pTreeView, GDK_BUTTON1_MASK | GDK_BUTTON2_MASK, target_table, n_targets, GDK_ACTION_COPY);
	gtk_drag_source_set (pTreeView, GDK_BUTTON1_MASK | GDK_BUTTON2_MASK, target_table, n_targets, GDK_ACTION_COPY);

//  gtk_drag_source_set(pTreeView, GDK_BUTTON1_MASK|GDK_BUTTON3_MASK,targetentries, 1,GDK_ACTION_MOVE | GDK_ACTION_COPY);
	g_signal_connect ((gpointer) pTreeView, "drag_data_get", G_CALLBACK (on_treeview1_drag_data_get), NULL);
	g_signal_connect ((gpointer) pTreeView, "drag_begin", G_CALLBACK (drag_begin), NULL);
	g_signal_connect ((gpointer) pTreeView, "drag_end", G_CALLBACK (drag_end), NULL);


	g_signal_connect ((gpointer) pTreeView, "row_activated", G_CALLBACK (row_activated), window);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_IconList), pTreeView);
	gtk_widget_show (pTreeView);

	return pTreeView;
}




void Creation_Mode_Liste ()
{
	GtkWidget *view;



	gtk_widget_destroy (iconlist);
	view = create_view_and_model ();
	Mode_Liste_Partage = TRUE;
	//gtk_container_add(GTK_CONTAINER(scrolledwindow_IconList), view);


}
