/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Reseau.h"
#include "callbacks.h"
#include "Machine.h"
#include <gtk/gtk.h>


gboolean Envoie_Pop3 (int Socket, char *Donnee)
{
	int       NbOctet;
	char      Temp[255], *chaine;

	if ((NbOctet = send (Socket, Donnee, strlen (Donnee), 0)) == 0) {
		printf ("[I] Envoie Pop3\n");
		close (Socket);
		return FALSE;
	}

	if ((NbOctet = recv (Socket, Temp, sizeof (Temp), 0)) == 0) {
		printf ("[I] Reception Pop3\n");
		close (Socket);
		return FALSE;
	}

	Temp[NbOctet] = 0;
	printf ("[I] Reponse Pop3 [%s]\n", Temp);
	if (strncmp (Temp, "+OK", 3) != 0) {
		printf ("[I] Erreur !!!\n");
		return FALSE;
	}
	return TRUE;

}

gboolean Pop3 (int Machine, char *User, char *Password)
{
	struct hostent *host;
	int       Socket, i, numMessage;
	long int  nBitTotal;
	int       NbOctet;
	char      Temp[255], *chaine;
	FILE     *In;


	gtk_text_set_point (GTK_EDITABLE (textview_Pop3), 0);
	gtk_text_forward_delete (GTK_EDITABLE (textview_Pop3), gtk_text_get_length (GTK_EDITABLE (textview_Pop3)));

	printf ("[I] Lecture Pop3 à la machine %d \n", Machine);
	if ((host = resoudre_DNS (Liste_Machines[MachineSelectionner].Adresse_Ip)) == NULL) {
		close (Socket);
		return FALSE;
	}
	Socket = Creation_Socket_TCP ();
	if (connection_Serveur (Liste_Machines[MachineSelectionner].Adresse_Ip, host, POP3, Socket) == FALSE) {
		printf ("[I] Impossible de se connecter\n");
		close (Socket);
		return FALSE;
	}

	printf ("[I] Recupération de l'en-tete\n");
	if ((NbOctet = recv (Socket, Temp, sizeof (Temp), 0)) == 0) {
		printf ("[I] Erreur Reception En-tete\n");
		close (Socket);
		return FALSE;
	}
	Temp[NbOctet] = 0;
	printf ("[I] En-tete[%s]\n", Temp);

	sprintf (Temp, "user %s\r\n", User);
	Envoie_Pop3 (Socket, Temp);
	sprintf (Temp, "pass %s\r\n", Password);
	if (!Envoie_Pop3 (Socket, Temp)){
		gtk_text_insert (GTK_EDITABLE (textview_Pop3), NULL, NULL, NULL, "Password Error !!", 17);
		return FALSE;
	}

	if ((NbOctet = send (Socket, "stat\r\n", 6, 0)) == 0) {
		printf ("[I] Erreur Envoie Pop3 stat\n");
		close (Socket);
		return FALSE;
	}

	if ((NbOctet = recv (Socket, Temp, sizeof (Temp), 0)) == 0) {
		printf ("[I] Erreur Reception Pop3\n");
		close (Socket);
		return FALSE;
	}
	Temp[NbOctet] = 0;
	sscanf (Temp, "+OK %d %li", &numMessage, &nBitTotal);
	sprintf (Temp, "Nb de message : %d   taille total : %li\n", numMessage, nBitTotal);
	gtk_text_insert (GTK_EDITABLE (textview_Pop3), NULL, NULL, NULL, Temp, strlen (Temp));

	In = fdopen (Socket, "r");
	if (In == NULL) {
		perror ("[I] Erreur  l'ouverture du flux en lecture");
		exit (-1);
	}
	for (i = 1; i < (numMessage + 1); i++) {
		sprintf (Temp, "Retr %d\r\n", i);
		if ((NbOctet = send (Socket, Temp, strlen (Temp), 0)) == 0) {
			printf ("[I] Envoie Pop3 Retr\n");
			close (Socket);
			return FALSE;
		}
		do {
			fgets (Temp, sizeof (Temp), In);
			gtk_text_insert (GTK_EDITABLE (textview_Pop3), NULL, NULL, NULL, Temp, strlen (Temp));
		} while (Temp[0] != '.');
	}
	close (Socket);
	return TRUE;
}
