/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#include "callbacks.h"
#include "Preference_Sous_Reseau.h"
#include "Reseau.h"


#define FIN 		-1
#define EFFACER 	NULL



void Ajoute_Nouveau_Sous_Reseau (char *buf, int Emplacement)
{
	if (sscanf (buf, "%d;%d;%d;%d;", &Liste_Sous_Reseau[Emplacement].Class, &Liste_Sous_Reseau[Emplacement].Prive1, &Liste_Sous_Reseau[Emplacement].Prive2, &Liste_Sous_Reseau[Emplacement].Prive3) != 4) {
		printf ("[I] Erreur de lecture du fichier Sous_Reseau\n");
		exit (0);
	}

}

void Creer_Liste_Sous_Reseau ()
{
	FILE     *Fichier_Sous_Reseau;
	char      buf[512], CheminFichier[256];


	sprintf (CheminFichier, "%s/.AutoScan/Conf/SubNet", Info_User->pw_dir);
	if ((Fichier_Sous_Reseau = fopen (CheminFichier, "r")) == NULL) {
		perror ("[I] fopen :");
		printf ("[I] Impossible de lire PortListe\n");
	}
	Nb_Sous_Reseau = 0;
	while (fgets (buf, sizeof (buf), Fichier_Sous_Reseau))
		Nb_Sous_Reseau++;
	rewind (Fichier_Sous_Reseau);
	Liste_Sous_Reseau = (struct struct_Liste_Sous_Reseau *) malloc (sizeof (struct struct_Liste_Sous_Reseau) * (Nb_Sous_Reseau + 1));
	Nb_Sous_Reseau = 0;
	while (fgets (buf, sizeof (buf), Fichier_Sous_Reseau)) {
		Ajoute_Nouveau_Sous_Reseau (buf, Nb_Sous_Reseau);
		Nb_Sous_Reseau++;
	}

	Liste_Sous_Reseau[Nb_Sous_Reseau].Class = FIN;	//FIN
	printf ("[I] Creation de la liste des sous reseaux (%d sous reseau trouves)\n", Nb_Sous_Reseau);
	fclose (Fichier_Sous_Reseau);
}


void Init_Sous_Reseau ()
{
	/* Initialise sous reseau */
	Modif_Sous_Reseau = TRUE;	// permet de ne pas prendre en compte les modifications par la fonction Preference_Sous_reseau_privee_changed
	Init_Sous_Res = TRUE;	// permet de ne pas prendre en compte les modifications par la on_combo_entry_Preference_Sous_reseau_privee_changed
	gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Ajouter, TRUE);
	gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Enlever, FALSE);
	gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Ok, FALSE);
	gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Annuler, FALSE);
	gtk_widget_set_sensitive (combo_Preference_Sous_reseau_privee, FALSE);
	gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_1), "");
	gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_2), "");
	gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_3), "");
	gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_1, FALSE);
	gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_2, FALSE);
	gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_3, FALSE);
	gtk_entry_set_text (GTK_ENTRY (combo_entry_Preference_Sous_reseau_privee), "255.0.0.0");
	gtk_editable_set_editable (GTK_EDITABLE (combo_entry_Preference_Sous_reseau_privee), FALSE);
	gtk_widget_set_sensitive (ctree_Preference_Sous_reseau_privee, TRUE);
	Sous_Reseau_Selectionner = -1;
	Modif_Sous_Reseau = FALSE;
	Ajout_Sous_Reseau = FALSE;
	Init_Sous_Res = FALSE;
}




void Affiche_liste_Sous_reseau ()
{
	gchar    *text[2];
	char      Tmp[255];
	int       i;
	GtkCTreeNode *Node;

	printf ("[I] Afficher Sous_Reseau\n");
	gtk_clist_clear (GTK_CLIST (ctree_Preference_Sous_reseau_privee));
	gtk_clist_freeze (GTK_CLIST (ctree_Preference_Sous_reseau_privee));

	for (i = 0; i < Nb_Sous_Reseau; i++) {
		if (Liste_Sous_Reseau[i].Class != EFFACER) {
			switch (Liste_Sous_Reseau[i].Class) {
			    case 1:
				    text[0] = g_strdup_printf ("255.0.0.0");
				    break;
			    case 2:
				    text[0] = g_strdup_printf ("255.255.0.0");
				    break;
			    case 3:
				    text[0] = g_strdup_printf ("255.255.255.0");
				    break;
			    default:
				    text[0] = g_strdup_printf ("????");
			}
			sprintf (Tmp, "%d.%d.%d.0", Liste_Sous_Reseau[i].Prive1, Liste_Sous_Reseau[i].Prive2, Liste_Sous_Reseau[i].Prive3);
			text[1] = g_strdup_printf (Tmp);
			Node = gtk_ctree_insert_node (GTK_CTREE (ctree_Preference_Sous_reseau_privee), NULL, NULL, text, 5, NULL, NULL, NULL, NULL, FALSE, FALSE);
			gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Preference_Sous_reseau_privee), Node, (gpointer *) i);
			Liste_Sous_Reseau[i].Node = Node;
			g_free (text[0]);
			g_free (text[1]);
		}
	}
	gtk_clist_thaw (GTK_CLIST (ctree_Preference_Sous_reseau_privee));
	Init_Sous_Reseau ();
}

void on_ctree_Preference_Sous_reseau_privee_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data)
{
	char      Tmp[512];

	Sous_Reseau_Selectionner = (int) gtk_ctree_node_get_row_data (GTK_CTREE (ctree), node);
	printf ("[I] Sous_Reseau : %d\n", Sous_Reseau_Selectionner);
	Modif_Sous_Reseau = TRUE;	// permet de ne pas prendre en compte les modifications par la fonction Preference_Sous_reseau_privee_changed
	Init_Sous_Res = TRUE;	// permet de ne pas prendre en compte les modifications par la on_combo_entry_Preference_Sous_reseau_privee_changed

	switch (Liste_Sous_Reseau[Sous_Reseau_Selectionner].Class) {
	    case 1:
		    gtk_entry_set_text (GTK_ENTRY (combo_entry_Preference_Sous_reseau_privee), "255.0.0.0");
		    gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_1, TRUE);
		    sprintf (Tmp, "%d", Liste_Sous_Reseau[Sous_Reseau_Selectionner].Prive1);
		    gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_1), Tmp);
		    gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_2), "");
		    gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_3), "");
		    break;
	    case 2:
		    gtk_entry_set_text (GTK_ENTRY (combo_entry_Preference_Sous_reseau_privee), "255.255.0.0");
		    gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_1, TRUE);
		    gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_2, TRUE);
		    sprintf (Tmp, "%d", Liste_Sous_Reseau[Sous_Reseau_Selectionner].Prive1);
		    gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_1), Tmp);
		    sprintf (Tmp, "%d", Liste_Sous_Reseau[Sous_Reseau_Selectionner].Prive2);
		    gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_2), Tmp);
		    gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_3), "");
		    break;
	    case 3:
		    gtk_entry_set_text (GTK_ENTRY (combo_entry_Preference_Sous_reseau_privee), "255.255.255.0");
		    gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_1, TRUE);
		    gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_2, TRUE);
		    gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_3, TRUE);
		    sprintf (Tmp, "%d", Liste_Sous_Reseau[Sous_Reseau_Selectionner].Prive1);
		    gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_1), Tmp);
		    sprintf (Tmp, "%d", Liste_Sous_Reseau[Sous_Reseau_Selectionner].Prive2);
		    gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_2), Tmp);
		    sprintf (Tmp, "%d", Liste_Sous_Reseau[Sous_Reseau_Selectionner].Prive3);
		    gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_3), Tmp);
		    break;
	    default:
		    gtk_entry_set_text (GTK_ENTRY (combo_entry_Preference_Sous_reseau_privee), "?????");
	}

	gtk_widget_set_sensitive (combo_Preference_Sous_reseau_privee, TRUE);
	gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Ajouter, TRUE);
	gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Enlever, TRUE);
	gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Ok, FALSE);
	gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Annuler, FALSE);
	Modif_Sous_Reseau = FALSE;
	Ajout_Sous_Reseau = FALSE;
	Init_Sous_Res = FALSE;
}

void on_combo_entry_Preference_Sous_reseau_privee_changed (GtkEditable * editable, gpointer user_data)
{
	if (((Modif_Sous_Reseau) || (Ajout_Sous_Reseau)) && (!Init_Sous_Res)) {
		printf ("[I] Modifie type sous reseau \n");
		if (strcmp (gtk_entry_get_text (GTK_ENTRY (combo_entry_Preference_Sous_reseau_privee)), "255.0.0.0") == 0) {
			gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_1, TRUE);
			gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_2, FALSE);
			gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_3, FALSE);
		}
		if (strcmp (gtk_entry_get_text (GTK_ENTRY (combo_entry_Preference_Sous_reseau_privee)), "255.255.0.0") == 0) {
			gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_1, TRUE);
			gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_2, TRUE);
			gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_3, FALSE);
		}
		if (strcmp (gtk_entry_get_text (GTK_ENTRY (combo_entry_Preference_Sous_reseau_privee)), "255.255.255.0") == 0) {
			gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_1, TRUE);
			gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_2, TRUE);
			gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_3, TRUE);
		}
	}
}


void Preference_Sous_reseau_privee_changed (GtkEditable * editable, gpointer user_data)
{
	if ((!Modif_Sous_Reseau) && (!Ajout_Sous_Reseau)) {
		gtk_widget_set_sensitive (ctree_Preference_Sous_reseau_privee, FALSE);
		gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Ok, TRUE);
		gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Annuler, TRUE);
		Modif_Sous_Reseau = TRUE;
		printf ("[I] Modifie sous reseau \n");
	}
}




void on_button_Preference_Sous_reseau_privee_Ajouter_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_set_sensitive (combo_Preference_Sous_reseau_privee, TRUE);
	gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_1, TRUE);
	gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_2, FALSE);
	gtk_widget_set_sensitive (entry_Preference_Sous_reseau_privee_3, FALSE);
	gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Ajouter, FALSE);
	gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Enlever, FALSE);
	gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Ok, TRUE);
	gtk_widget_set_sensitive (button_Preference_Sous_reseau_privee_Annuler, TRUE);
	gtk_entry_set_text (GTK_ENTRY (combo_entry_Preference_Sous_reseau_privee), "255.0.0.0");
	gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_1), "");
	gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_2), "");
	gtk_entry_set_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_3), "");
	Ajout_Sous_Reseau = TRUE;

}


void on_button_Preference_Sous_reseau_privee_Enlever_clicked (GtkButton * button, gpointer user_data)
{
	if (Sous_Reseau_Selectionner != -1) {
		printf ("[I] Suppression du sous reseau %d\n", Sous_Reseau_Selectionner);
		gtk_ctree_remove_node (ctree_Preference_Sous_reseau_privee, Liste_Sous_Reseau[Sous_Reseau_Selectionner].Node);
		Liste_Sous_Reseau[Sous_Reseau_Selectionner].Class = EFFACER;
		Sous_Reseau_Selectionner = -1;
		Init_Sous_Reseau ();
	}
}




void on_button_Preference_Sous_reseau_privee_Ok_clicked (GtkButton * button, gpointer user_data)
{
	gchar    *text[2];
	char      Tmp[512];
	GtkCTreeNode *Node;
	int       Prive1, Prive2, Prive3, Class;

	if (Modif_Sous_Reseau) {
		printf ("[I] Suppression Modification d'un sous reseau \n");
		gtk_ctree_remove_node (ctree_Preference_Sous_reseau_privee, Liste_Sous_Reseau[Sous_Reseau_Selectionner].Node);
		Liste_Sous_Reseau[Sous_Reseau_Selectionner].Class = EFFACER;
	}
	printf ("[I] Ajout d'un sous reseau \n");
	Class = 0;
	Prive1 = 0;
	Prive2 = 0;
	Prive3 = 0;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (combo_entry_Preference_Sous_reseau_privee)), "255.0.0.0") == 0)
		Class = 1;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (combo_entry_Preference_Sous_reseau_privee)), "255.255.0.0") == 0)
		Class = 2;
	if (strcmp (gtk_entry_get_text (GTK_ENTRY (combo_entry_Preference_Sous_reseau_privee)), "255.255.255.0") == 0)
		Class = 3;


	if (sscanf (gtk_entry_get_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_1)), "%d", &Prive1) != 1) {
		printf ("[I] Erreur recuperation privee1\n");
		Message ("Syntax error", GNOME_MESSAGE_BOX_ERROR);
		return;
	}

	if (Class > 1)
		if (sscanf (gtk_entry_get_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_2)), "%d", &Prive2) != 1) {
			printf ("[I] Erreur recuperation privee2\n");
			Message ("Syntax error", GNOME_MESSAGE_BOX_ERROR);
			return;
		}

	if (Class == 3)
		if (sscanf (gtk_entry_get_text (GTK_ENTRY (entry_Preference_Sous_reseau_privee_3)), "%d", &Prive3) != 1) {
			printf ("[I] Erreur recuperation privee3\n");
			Message ("Syntax error", GNOME_MESSAGE_BOX_ERROR);
			return;
		}

	sprintf (Tmp, "%d;%d;%d;%d;", Class, Prive1, Prive2, Prive3);
	/* Redimensionne le tableau */
	if ((Liste_Sous_Reseau = realloc (Liste_Sous_Reseau, sizeof (struct struct_Liste_Sous_Reseau) * (Nb_Sous_Reseau + 2))) == NULL) {
		printf ("[I] Realloc erreur\n");
		exit (0);
	}
	/* Ajoute la nouveau sous reseau dans le tableau */
	Ajoute_Nouveau_Sous_Reseau (Tmp, Nb_Sous_Reseau);
	Nb_Sous_Reseau++;
	Liste_Sous_Reseau[Nb_Sous_Reseau].Class = FIN;	//FIN   
	/* Affiche la nouvelle entree dans la liste */
	text[0] = g_strdup_printf (gtk_entry_get_text (GTK_ENTRY (combo_entry_Preference_Sous_reseau_privee)));
	sprintf (Tmp, "%d.%d.%d.0", Prive1, Prive2, Prive3);
	text[1] = g_strdup_printf (Tmp);
	Node = gtk_ctree_insert_node (GTK_CTREE (ctree_Preference_Sous_reseau_privee), NULL, NULL, text, 5, NULL, NULL, NULL, NULL, FALSE, FALSE);
	gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Preference_Sous_reseau_privee), Node, (gpointer *) (Nb_Sous_Reseau - 1));
	Liste_Sous_Reseau[Nb_Sous_Reseau - 1].Node = Node;
	g_free (text[0]);
	g_free (text[1]);
	Init_Sous_Reseau ();
}


void on_button_Preference_Sous_reseau_privee_Annuler_clicked (GtkButton * button, gpointer user_data)
{
	if (Modif_Sous_Reseau)
		printf ("[I] Annulation Modification d'un sous reseau \n");
	else
		printf ("[I] Annulation Ajout d'un sous reseau \n");
	Init_Sous_Reseau ();
}





void Annuler_Sous_Reseau ()
{
	/* Libere la liste des sous reseaux */
	free (Liste_Sous_Reseau);
	/* Créer une nouvelle liste avec le contenu du fichier */
	Creer_Liste_Sous_Reseau ();

}


void Enregistrer_Sous_Reseau ()
{
	FILE     *Fichier_Sous_Reseau;
	char      buf[512], CheminFichier[255];
	int       i;

	/* Enregistrement de la liste des scripts */
	sprintf (CheminFichier, "%s/.AutoScan/Conf/SubNet", Info_User->pw_dir);
	if ((Fichier_Sous_Reseau = fopen (CheminFichier, "w")) == NULL) {
		perror ("[I] fopen :");
		printf ("[I] Impossible de ecrire SubNet\n");
		exit (-1);
	}
	for (i = 0; i < Nb_Sous_Reseau; i++) {
		if (Liste_Sous_Reseau[i].Class != EFFACER) {
			sprintf (buf, "%d;%d;%d;%d;\n", Liste_Sous_Reseau[i].Class, Liste_Sous_Reseau[i].Prive1, Liste_Sous_Reseau[i].Prive2, Liste_Sous_Reseau[i].Prive3);
			/* Enregistrement */
			if (fputs (buf, Fichier_Sous_Reseau) != 1)
				printf ("[I] Erreur Ecriture fichier SubNet\n");
		}
	}
	fclose (Fichier_Sous_Reseau);
	/* Libere la liste des sous reseaux */
	free (Liste_Sous_Reseau);
	/* Créer une nouvelle liste avec le contenu du fichier */
	Creer_Liste_Sous_Reseau ();
}
