/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef         __RESEAU
#define         __RESEAU


#include <pwd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/if_ether.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <linux/sockios.h>
#include <unistd.h>
#include <fcntl.h>
#include <asm/poll.h>
#include <linux/if_packet.h>
#include  <netdb.h>
#include <gtk/gtk.h>
#include <errno.h>
#include <semaphore.h>
#include "Commun.h"
/* num sélection liste */
#define INCONNU -1
#define MATERIEL -2
#define STATION -3
#define SERVEUR -4
#define SWITCH -5
#define ROUTEUR -6
#define IMPRIMANTE -7
#define ROUTEUR_SWITCH -8
#define POINT_ACCESS_WIFI -9
#define AUTRE -10
#define DOMAINE -11
#define FIREWALL -11

#define ARRET 0
#define ARRET_CONTROL_C 1

/* Type de datagramme */
#define TRAME_ARP	0x0806
#define TRAME_IP	0x0800

/* Type de message */
#define UDP		0x11
#define ICMP	0x01
#define TCP 0x06

/* Protocole */
#define DNS 53
#define SMTP 25
#define POP3 110
#define HTTP 80
#define NETBIOS		0x89
#define BROWSE		0x8a
#define NBNS	0x89


/* Ip */
#define IP_VERSION4	0x4

/* TCP */
#define TCP_ACK	16
#define TCP_PUSH 	8
#define TCP_RESET 4
#define TCP_SYN		2
#define TCP_FIN		1
#define TCP_PUSH_ACK 0x18


/* Définition constante message BROWSE*/
#define MASTER_ANNONCE	0x0f
#define HOST_ANNONCE	0x01
#define DOMAIN_ANNONCE 0x0C
#define REQUEST_ANNONCE 0x02
#define BROWSER_ELECTION 0x08



#define IP_ADDR_LEN	4
#define ARP_ETHER       1

#define REGISTRATION_GROUP 1
#define REGISTRATION_UNIQUE 2



struct passwd *Info_User;
char     *Interface;
int       MachineSelectionner;
int       IconeSelectionner;
int       IconeSelectionner_Nouveau;
gboolean  Mode_Liste_Icone_Port;
gboolean Demarrage;
gboolean  Root_Afficher;
gboolean Bug_autoscan_d;


/* Liste des adresses MAC  */
typedef struct {
	unsigned char MAC[3];
	char     *Constructeur;
} struct_MacListe;

struct_MacListe *MacListe;
int       NbMacAdresse;

/* Semaphore utilise pour limite le nombre de thread_scan */
sem_t     Semaphore_Nouvelle_Machine;
sem_t     Semaphore_Thread_Scan;


unsigned char Mon_Adresse_Ip[16];
unsigned long int MonAdresseIp;
unsigned char MonAdresseMac[ETH_ALEN];

struct struct_trame {
	unsigned char Dest_MAC[6];
	unsigned char Source_MAC[6];
	unsigned short Proto;
	unsigned char Datagramme[10000];
	int       Taille_Trame;
};


gboolean  Scan_Actif;

void      Get_My_MAC (int fd, char *Interface);
void      Get_My_Ip (int fd, char *Interface);
void      Get_Sous_Reseau (int fd, char *Interface);
void      Liste_Interface ();
#endif
