/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <libsmbclient.h>
#include "Reseau.h"
#include "callbacks.h"
#include "Commun.h"
#include "Machine.h"
#include "Samba.h"



enum {
	BMP_COLUMN,
	TEXT_COLUMN,
	POINTER,
	N_COLUMN
};


struct Struct_Type_Fichier_Default {
	char     *extension;
	char     *Fichier_Icone;
} Type_Fichier_Default[] = {
	{
	".sxc", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/004_spreadsheet_document.png"}, {
	".sxd", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/006_drawing_document.png"}, {
	".sxi", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/008_presentation_document.png"}, {
	".png", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/gimp.png"}, {
	".rpm", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/kpackage.png"}, {
	".mp3", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/mime_audio.png"}, {
	".html", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/mozilla_doc.png"}, {
	".pdf", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/pdf.png"}, {
	"readme", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/readme.png"}, {
	".sxw", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/soffice.png"}, {
	".c", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/source_c.png"}, {
	".h", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/source_h.png"}, {
	".tar", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/tar.png"}, {
	".txt", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/txt.png"}, {
	".avi", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/video.png"}, {
	".doc", "/usr/share/pixmaps/AutoScan/Modes/File Sharing/wordprocessing.png"}, {
NULL, NULL}};

void Init_Liste_Partage_Monter ()
{
	Partage_monter = (struct struct_Partage_Monter *) malloc (sizeof (struct struct_Partage_Monter));
	Partage_monter[0].Num_Machine = -1;
	Partage_monter[0].Nom_Machine = NULL;
	Partage_monter[0].Nom_Partage = NULL;
	Partage_monter[0].Toujours_monter = FALSE;
}


void Monte_Partage (int Num_Machine, char *Nom_Machine, char *Nom_Partage)
{
	int       i;
	pid_t     pid_fils;
	char      Nom_Fichier[255];
	char      Tmp[255];

	i = 0;
	printf ("[I] premier partage liste : [%s]\n", Partage_monter[0].Nom_Machine);
	while (Partage_monter[i].Nom_Machine != NULL) {
		printf ("[I] pos(%d) premier : [%s]/[%s]   %d\n", i, Partage_monter[i].Nom_Machine, Partage_monter[i].Nom_Partage, Partage_monter[i].Nom_Machine);
		if ((Partage_monter[i].Num_Machine == Num_Machine) && (strcmp (Partage_monter[i].Nom_Machine, Nom_Machine) == 0) && (strcmp (Partage_monter[i].Nom_Partage, Nom_Partage) == 0))
			if (Partage_monter[i].Toujours_monter) {
				printf ("[I] pos(%d) Partage deja monte : [%s]/[%s]\n", i, Partage_monter[i].Nom_Machine, Partage_monter[i].Nom_Partage);
				return;	// le partage existe + toujours monte
			}
			else {
				printf ("[I] existe mais demonté\n");
				continue;	// partage existe mais demonte
			}
		i++;
		printf ("[I] +\n");
		printf ("[I] [%s]\n", Partage_monter[i].Nom_Machine);
	}

	if (Partage_monter[i].Nom_Machine == NULL) {
		Partage_monter[i].Num_Machine = Num_Machine;
		Partage_monter[i].Nom_Machine = malloc (strlen (Nom_Machine) + 1);
		strcpy (Partage_monter[i].Nom_Machine, Nom_Machine);
		Partage_monter[i].Nom_Partage = malloc (strlen (Nom_Machine) + 1);
		strcpy (Partage_monter[i].Nom_Partage, Nom_Partage);
		Partage_monter[i].Toujours_monter = TRUE;
		/* Redimensionne le tableau */
		if ((Partage_monter = (struct struct_Partage_Monter *) realloc (Partage_monter, sizeof (struct struct_Partage_Monter) * (i + 2))) == NULL) {
			printf ("[I] Realloc erreur\n");
			exit (0);
		}
		printf ("[I] pos(%d) Nouveau partage : [%s]/[%s]\n", i, Partage_monter[i].Nom_Machine, Partage_monter[i].Nom_Partage);
		Partage_monter[i + 1].Num_Machine = -1;
		Partage_monter[i + 1].Nom_Machine = NULL;
		Partage_monter[i + 1].Nom_Partage = NULL;
		Partage_monter[i + 1].Toujours_monter = FALSE;
	}
	else {
		printf ("[I] pos(%d) partage existant : [%s]/[%s]\n", i, Partage_monter[i].Nom_Machine, Partage_monter[i].Nom_Partage);
		Partage_monter[i].Toujours_monter = TRUE;
	}
	pid_fils = fork ();	// création d'un fils
	if (pid_fils == 0) {
		// Fils 
		// Creation du repertoire Mount 
		sprintf (Nom_Fichier, "%s/.AutoScan/Mount/", Info_User->pw_dir);
		if (mkdir (Nom_Fichier, 0755) != 0)
			printf ("[I] Mkdir : Erreur\n");
		// Creation du repertoire correspondant au partage 
		sprintf (Nom_Fichier, "%s/.AutoScan/Mount/%s_%s/", Info_User->pw_dir, Nom_Machine, Nom_Partage);
		if (mkdir (Nom_Fichier, 0755) != 0)
			printf ("Mkdir : Erreur\n");
		sprintf (Tmp, "smbmount '//%s/%s' '%s' -o username=%s%c%s,workgroup=%s", Nom_Machine, Nom_Partage, Nom_Fichier, gtk_entry_get_text (GTK_ENTRY (entry_Partage_Utilisateur)), '%', gtk_entry_get_text (GTK_ENTRY (entry_Partage_Mot_Passe)), gtk_entry_get_text (GTK_ENTRY (entry_Partage_Domaine)));
		printf ("[I] Commande : [%s]\n", Tmp);
		if (system (Tmp) < 0)
			printf ("[I] Erreur : Montage [%s/%s]\n", Nom_Machine, Nom_Partage);
		else
			printf ("[I] Montage OK [%s/%s]\n", Nom_Machine, Nom_Partage);
		exit (127);
	}
}

void Demonte_Tout_Partage ()
{
	int       i;
	char      Tmp[255];

	i = 0;
	printf ("[I] premier partage liste : [%s]\n", Partage_monter[0].Nom_Machine);
	while (Partage_monter[i].Nom_Machine != NULL) {
		printf ("[I] pos(%d) premier : [%s]/[%s]\n", i, Partage_monter[i].Nom_Machine, Partage_monter[i].Nom_Partage);
		if (Partage_monter[i].Toujours_monter) {
			printf ("[I] pos(%d) Demontage Partage : [%s]/[%s]\n", i, Partage_monter[i].Nom_Machine, Partage_monter[i].Nom_Partage, Partage_monter[i].Nom_Partage);
			sprintf (Tmp, "smbumount '%s/.AutoScan/Mount/%s_%s/'", Info_User->pw_dir, Partage_monter[i].Nom_Machine, Partage_monter[i].Nom_Partage);
			printf ("[I] Commande : [%s]\n", Tmp);
			if (system (Tmp) < 0)
				printf ("[I] Erreur Demontage : [%s]\n", Tmp);
			else
				printf ("[I] Demontage : OK\n");

		}
		i++;
		printf ("[I] +\n");
		printf ("[I] [%s]\n", Partage_monter[i].Nom_Machine);
	}
}



static void auth_fn (const char *server, const char *share, char *workgroup, int wgmaxlen, char *username, int unmaxlen, char *password, int pwmaxlen)
{
	printf ("[I] Password init\n");
	strcpy (username, gtk_entry_get_text (GTK_ENTRY (entry_Partage_Utilisateur)));
	strcpy (password, gtk_entry_get_text (GTK_ENTRY (entry_Partage_Mot_Passe)));
	strcpy (workgroup, gtk_entry_get_text (GTK_ENTRY (entry_Partage_Domaine)));
	printf ("[I] Password init   user[%s]  pass[%s]  dom[%s]\n", username, password, workgroup);
}



gboolean init_Samba ()
{
	char      Message_Erreur[255];

	if (smbc_init (auth_fn, 0) < 0) {
		sprintf (Message_Erreur, "smbc_init returned %s (%i)\nDo you have a ~/.smb/smb.conf file?\n", strerror (errno), errno);
		Message (Message_Erreur, GNOME_MESSAGE_BOX_ERROR);
		return FALSE;
	}
	return TRUE;
}







char      string2[] = "file:/home/thierry/cube.xpm\r\0";
gboolean on_iconlist_text_changed (GnomeIconList * iconlist, gint num, gchar * new_text, gpointer user_data)
{
	if (!Mode_Liste_Icone_Port) {
		printf ("on_iconlist_text_changed  [%s]\n", new_text);
		return TRUE;
		return FALSE;
	}
}


void on_iconlist_drag_begin (GtkWidget * widget, GdkDragContext * drag_context, gpointer user_data)
{
	if (!Mode_Liste_Icone_Port) {
		printf ("on_iconlist_drag_begin\n");

	}
}


void on_iconlist_drag_data_get (GtkWidget * widget, GdkDragContext * drag_context, GtkSelectionData * data, guint info, guint time, gpointer user_data)
{
	GList    *p;
	int       dlen, num, i, Taille_Total;
	char     *Fichiers,*Fichiers_Debut;

	if (!Mode_Liste_Icone_Port) {
		p = gnome_icon_list_get_selection (GNOME_ICON_LIST (iconlist));
		dlen = g_list_length (p);
		printf ("[I] (%d) icone selectionne\n", dlen);
		Taille_Total = 1;	// 1 pour \0 final
		for (i = 0; i < dlen; i++) {
			num = GPOINTER_TO_INT (p->data);
			printf ("num [%d] [%s]\n", num, gnome_icon_list_get_icon_data (GNOME_ICON_LIST (iconlist), num));
			Taille_Total = Taille_Total + strlen (gnome_icon_list_get_icon_data (GNOME_ICON_LIST (iconlist), num)) + 1 + strlen( Info_User->pw_dir)+ 17 ;	// +1 pour \n  17 = "/.AutoScan/Mount/"
			p = p->next;
		}
		Fichiers = malloc (Taille_Total);
		strcpy (Fichiers, "");
		p = gnome_icon_list_get_selection (GNOME_ICON_LIST (iconlist));
		for (i = 0; i < dlen; i++) {
			num = GPOINTER_TO_INT (p->data);
			Fichiers_Debut = Fichiers;
			strcpy(Fichiers, Info_User->pw_dir);
			strcat(Fichiers, "/.AutoScan/Mount/");
			strcat (Fichiers, gnome_icon_list_get_icon_data (GNOME_ICON_LIST (iconlist), num)+6);
			Fichiers_Debut[strlen(Info_User->pw_dir)+17+ strlen (Liste_Machines[MachineSelectionner].Smb.HostName)] = '_';
			strcat (Fichiers, "\n");
			p = p->next;
		}

		printf ("Fichier : [%s]\n", Fichiers);
		gtk_selection_data_set (data, data->target, 8, Fichiers, strlen (Fichiers));
		free (Fichiers);
		printf ("on_treeview1_drag_data_get\n");
		printf ("Got: %s\n", data->data);
		printf ("on_iconlist_drag_data_get\n");
	}
}


void on_iconlist_drag_data_received (GtkWidget * widget, GdkDragContext * drag_context, gint x, gint y, GtkSelectionData * data, guint info, guint time, gpointer user_data)
{
	if (!Mode_Liste_Icone_Port) {
		printf ("[%s]\n", data->data);
		strcpy (string2, data->data);
		printf ("on_iconlist_drag_data_received\n");
		Message ("This feature is not yet implemented", GNOME_MESSAGE_BOX_INFO);
	}
}


void on_iconlist_drag_end (GtkWidget * widget, GdkDragContext * drag_context, gpointer user_data)
{
	if (!Mode_Liste_Icone_Port) {
		printf ("on_iconlist_drag_end\n");
		gnome_icon_list_unselect_all (GNOME_ICON_LIST (iconlist));
	}
}


gboolean Affiche_Liste_Partage_Samba (char *chemin)
{
	char      dirbuf[512];
	struct smbc_dirent *dirp;
	char      Message_Erreur[255];
	int       err, dh, pos, i;
	char     *Donnee_Icone;
	char     *Fichier_Icone;

	printf ("[I] Afficher Samba : [%s]\n", chemin);
	if ((dh = smbc_opendir (chemin)) < 0) {
		sprintf (Message_Erreur, "Could not list workgroups: %s: %s\n", chemin, strerror (errno));
		Message (Message_Erreur, GNOME_MESSAGE_BOX_ERROR);
		gtk_widget_set_sensitive (iconlist, TRUE);
		return FALSE;
	}

	gnome_icon_list_clear (GNOME_ICON_LIST (iconlist));
	gtk_widget_grab_focus (iconlist);
	gnome_icon_list_freeze (GNOME_ICON_LIST (iconlist));
	pos = 0;
	while ((err = smbc_getdents (dh, (struct smbc_dirent *) dirbuf, sizeof (dirbuf))) != 0) {
		if (err < 0) {	/* Handle the error */
			sprintf (Message_Erreur, "Could not read directory for %s : %s\n", chemin, strerror (errno));
			Message (Message_Erreur, GNOME_MESSAGE_BOX_ERROR);
			gtk_widget_set_sensitive (iconlist, TRUE);
			return FALSE;
		}

		dirp = (struct smbc_dirent *) dirbuf;
		printf ("[I] Dir len: %u\n", err);
		while (err > 0) {
			int       dirlen = dirp->dirlen;

			printf ("Type : ");
			switch (dirp->smbc_type) {
			    case SMBC_WORKGROUP:
				    printf ("WORKGROUP");
				    break;
			    case SMBC_SERVER:
				    printf ("SERVER");
				    break;
			    case SMBC_FILE_SHARE:
				    printf ("FILE_SHARE");
				    gnome_icon_list_append (GNOME_ICON_LIST (iconlist), "/usr/share/pixmaps/AutoScan/folder.png", dirp->name);
				    Donnee_Icone = (char *) malloc (strlen (dirp->name) + strlen (chemin) + 3);	// 3 =  "/" + "\n" + "/"
				    strcpy (Donnee_Icone, chemin);
				    // strcat (Donnee_Icone, "/");
				    strcat (Donnee_Icone, dirp->name);
				    strcat (Donnee_Icone, "/");
				    printf ("Donnee_Icone : [%s] (%d)=(%d)\n", Donnee_Icone, strlen (Donnee_Icone) + 1, strlen (dirp->name) + strlen (chemin) + 1);
				    gnome_icon_list_set_icon_data_full (GNOME_ICON_LIST (iconlist), pos, Donnee_Icone, NULL);
				    pos++;
				    break;
			    case SMBC_PRINTER_SHARE:
				    printf ("PRINTER_SHARE");
				    //gnome_icon_list_append (GNOME_ICON_LIST (iconlist), "/usr/share/pixmaps/AutoScan/printer2.png", dirp->name);
				    //gnome_icon_list_set_icon_data_full (GNOME_ICON_LIST (iconlist), pos, g_strdup_printf (dirp->name), NULL);
				    //pos++;
				    break;
			    case SMBC_COMMS_SHARE:
				    printf ("COMMS_SHARE");
				    break;
			    case SMBC_IPC_SHARE:
				    printf ("IPC_SHARE");
				    break;
			    case SMBC_DIR:
				    printf ("DIR");
				    if (strcmp (dirp->name, "..") != 0) {
					    gnome_icon_list_append (GNOME_ICON_LIST (iconlist), "/usr/share/pixmaps/AutoScan/folder.png", dirp->name);
					    Donnee_Icone = (char *) malloc (strlen (dirp->name) + strlen (chemin) + 3);	// 3 =  "/" + "\n" + "/"
					    if (strcmp (dirp->name, ".") == 0) {
						    strcpy (Donnee_Icone, chemin);
						    Donnee_Icone[strlen (Donnee_Icone) - 1] = 0;
						    printf ("[%s]  [%s]\n", rindex (Donnee_Icone, '/'), rindex (rindex (Donnee_Icone, '/') - 1, '/'));
						    printf ("[%s] %d  - %d\n", Donnee_Icone, rindex (rindex (Donnee_Icone, '/') - 1, '/'), Donnee_Icone);
						    Donnee_Icone[rindex (rindex (Donnee_Icone, '/') - 1, '/') - Donnee_Icone + 1] = 0;
						    printf ("[I]  retour : [%s]\n", Donnee_Icone);
					    }
					    else {
						    strcpy (Donnee_Icone, chemin);
						    // strcat (Donnee_Icone, "/");
						    strcat (Donnee_Icone, dirp->name);
						    strcat (Donnee_Icone, "/");
					    }
					    printf ("Donnee_Icone : [%s] (%d)=(%d)\n", Donnee_Icone, strlen (Donnee_Icone) + 1, strlen (dirp->name) + strlen (chemin) + 1);
					    gnome_icon_list_set_icon_data_full (GNOME_ICON_LIST (iconlist), pos, Donnee_Icone, NULL);
					    pos++;
				    }
				    break;
			    case SMBC_FILE:
				    printf ("FILE");
				    Fichier_Icone = NULL;
				    i = 0;
				    while ((Fichier_Icone == NULL) && (Type_Fichier_Default[i].extension != NULL)) {
					    //printf("[%s] == [%s]\n",dirp->name +strlen(dirp->name)-strlen(Type_Fichier_Default[i].extension),Type_Fichier_Default[i].extension);
					    if (strcmp (dirp->name + strlen (dirp->name) - strlen (Type_Fichier_Default[i].extension), Type_Fichier_Default[i].extension) == 0)
						    Fichier_Icone = Type_Fichier_Default[i].Fichier_Icone;
					    i++;
				    }
				    if (Fichier_Icone == NULL)
					    gnome_icon_list_append (GNOME_ICON_LIST (iconlist), "/usr/share/pixmaps/AutoScan/file.png", dirp->name);
				    else
					    gnome_icon_list_append (GNOME_ICON_LIST (iconlist), Fichier_Icone, dirp->name);
				    Donnee_Icone = (char *) malloc (strlen (dirp->name) + strlen (chemin) + 2);	// 2 =  "/" + "\n"
				    strcpy (Donnee_Icone, chemin);
				    //strcat (Donnee_Icone, "/");
				    strcat (Donnee_Icone, dirp->name);
				    printf ("Donnee_Icone : [%s] (%d)=(%d)\n", Donnee_Icone, strlen (Donnee_Icone) + 1, strlen (dirp->name) + strlen (chemin) + 1);
				    gnome_icon_list_set_icon_data_full (GNOME_ICON_LIST (iconlist), pos, Donnee_Icone, NULL);
				    pos++;
				    break;
			    case SMBC_LINK:
				    printf ("LINK");
				    break;
			    default:
				    printf ("Inconnu (%d)", dirp->smbc_type);
			}
			printf (" %s\n", dirp->name);
			(char *) dirp += dirlen;
			err -= dirlen;
		}
	}
	//gnome_icon_list_set_selection_mode (GNOME_ICON_LIST (iconlist), GTK_SELECTION_EXTENDED);
	gnome_icon_list_thaw (GNOME_ICON_LIST (iconlist));
	gtk_widget_set_sensitive (iconlist, TRUE);
	smbc_closedir (dh);
	IconeFocus = -1;
	return TRUE;
}
