/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Script.h"
#include "Reseau.h"
#include "callbacks.h"
#include "Machine.h"


extern int h_errno;

#define FIN 				-1
#define EFFACER 	NULL

GtkWidget *root_menu = NULL;
GtkWidget *menu_items;
GtkWidget *menu_script, *menu;

char     *Gestion_Variable (char *command, char *Chaine_Variable, int *pTaille, char *Remplace)
{
	char     *pVariable, *Suite;
	int       Taille_Suite, Variable;
	char     *Retour;
	int       Taille_Remplacement;

	printf ("[I] Gestion_Variable   [%s]  [%s]  Taille [%d]\n", command, Chaine_Variable, *pTaille);

	if ((pVariable = strstr (command, Chaine_Variable)) != 0) {
		Taille_Remplacement = strlen (Remplace);
		Variable = (pVariable - command);
		Taille_Suite = *pTaille - Variable - strlen (Chaine_Variable);
		printf ("[I] Debut Variable : [%s]   Nouvelle Taille : (%d) Variable (%d)\n\n", &command[Variable], *pTaille, Variable);

		Suite = (char *) malloc (Taille_Suite);
		strcpy (Suite, (command + Variable + strlen (Chaine_Variable)));
		*pTaille = *pTaille + (Taille_Remplacement - strlen (Chaine_Variable));	//xxx.xxx.xxx.xxx 15 - _IP_ 4 = 11
		printf ("[I] Debut Variable : [%s]   Nouvelle Taille : (%d) \n Taille suite (%d)   Suite [%s]\n", &command[Variable], *pTaille, Taille_Suite, Suite);
		command = (char *) realloc (command, *pTaille);
		strcpy (&command[Variable], Remplace);
		strcat (&command[Variable + Taille_Remplacement], Suite);
		free (Suite);
	}
	return command;
}


static void menuitem_response (GtkWidget * widget, int user_data)
{
	char     *command, *pVariable, *Suite;
	int       Taille, Taille_Suite, Variable;
	char     *Retour, *pRetour;
	int       pid_fils;
	struct struct_Message Message_Envoyer;
	int       TailleDejaEnvoyer, Taille_Retour, TailleEnvoyer;
	FILE     *sortie;
	char      ligne[128];


	pid_fils = fork ();	// création d'un fils
	if (pid_fils == 0) {
		/* Fils */
		printf ("[I] Script Selectionner : (%d)   %s %s\n", user_data, Liste_Script[user_data].Chemin, Liste_Script[user_data].Parametres);
		Taille = sizeof (char) * (strlen (Liste_Script[user_data].Chemin) + strlen (Liste_Script[user_data].Parametres) + 2);
		command = (char *) malloc (Taille);
		strcpy (command, Liste_Script[user_data].Chemin);
		strcat (command, " ");
		strcat (command, Liste_Script[user_data].Parametres);
		printf ("[I] Commande : [%s]  taille (%d) (%d)\n", command, Taille, &Taille);
		command = Gestion_Variable (command, "_IP_", &Taille, Liste_Machines[MachineSelectionner].Adresse_Ip);
		printf ("[I] Commande : [%s]  taille (%d)\n", command, Taille);
		command = Gestion_Variable (command, "_MAC_", &Taille, Liste_Machines[MachineSelectionner].Adresse_Mac);
		printf ("[I] Commande : [%s]  taille (%d)\n", command, Taille);

		if ((sortie = popen (command, "r")) == NULL) {
			printf (" Erreur popen %d \n", errno);
			exit (127);
		}

		while (fgets (ligne, 127, sortie) != NULL) {
			Message_Envoyer.type = 1;
			Message_Envoyer.type_message = RETOUR_SCRIPT;
			TailleEnvoyer = strlen(ligne);
			strncpy (Message_Envoyer.donnee, ligne, TailleEnvoyer);
			Message_Envoyer.donnee[TailleEnvoyer] = 0;
			if (msgsnd (File_Envoie_Message, (void *) &Message_Envoyer, sizeof (Message_Envoyer) - sizeof (long), 0) < 0) {
				perror ("[I] msgsnd");
				exit (127);
			}
		}
		pclose (sortie);
		Message_Envoyer.type = 1;
		Message_Envoyer.type_message = RETOUR_SCRIPT_TERMINE;
		Message_Envoyer.donnee[0] = 0;
		if (msgsnd (File_Envoie_Message, (void *) &Message_Envoyer, sizeof (Message_Envoyer) - sizeof (long), 0) < 0) {
			perror ("[I] msgsnd");
			exit (117);
		}
		free (command);
		exit (127);


		/*Retour = Execute_Retour (command);
		 * printf ("[I] Retour : [%s]\n", Retour);
		 * TailleDejaEnvoyer = 0;
		 * TailleEnvoyer = 0;
		 * Taille_Retour = strlen (Retour);
		 * pRetour = Retour;
		 * 
		 * while (Taille_Retour != TailleDejaEnvoyer) {
		 * pRetour = Retour + TailleDejaEnvoyer;
		 * if ((Taille_Retour - TailleDejaEnvoyer) > 254)
		 * TailleEnvoyer = 254;
		 * else
		 * TailleEnvoyer = (Taille_Retour - TailleDejaEnvoyer);
		 * TailleDejaEnvoyer = TailleDejaEnvoyer + TailleEnvoyer;
		 * Message_Envoyer.type = 1;
		 * Message_Envoyer.type_message = RETOUR_SCRIPT;
		 * strncpy (Message_Envoyer.donnee, pRetour, TailleEnvoyer);
		 * Message_Envoyer.donnee[TailleEnvoyer] = 0;
		 * if (msgsnd (File_Envoie_Message, (void *) &Message_Envoyer, sizeof (Message_Envoyer) - sizeof (long), 0) < 0) {
		 * perror ("[I] msgsnd");
		 * exit (1);
		 * }
		 * }
		 * Message_Envoyer.type = 1;
		 * Message_Envoyer.type_message = RETOUR_SCRIPT_TERMINE;
		 * Message_Envoyer.donnee[0] = 0;
		 * if (msgsnd (File_Envoie_Message, (void *) &Message_Envoyer, sizeof (Message_Envoyer) - sizeof (long), 0) < 0) {
		 * perror ("[I] msgsnd");
		 * exit (1);
		 * } 
		 free (command);
		 //free (Retour);
		 exit (127);*/
	}

}



void Creer_Menu_Script ()
{
	char      buf[128];
	int       i;


	if (root_menu != NULL) {
		printf ("[I] Le menu existe deja\n");
		gtk_menu_detach (menu_script);
		menu_script = gtk_menu_new ();
	}
	else {
		menu_script = gtk_menu_new ();
		root_menu = gtk_menu_item_new_with_label ("Script");
		gtk_widget_show (root_menu);
		gtk_menu_append (GTK_MENU (menu_Liste_Machine), root_menu);
		gtk_menu_reorder_child (GTK_MENU (menu_Liste_Machine), root_menu, 3);
	}
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (root_menu), menu_script);
	printf ("[I] Creation Menu Script  (%d script trouve)\n", Nb_Script_Dans_Liste);
	for (i = 0; i < Nb_Script_Dans_Liste; i++) {
		menu_items = gtk_menu_item_new_with_label (Liste_Script[i].Nom);
		gtk_menu_append (GTK_MENU (menu_script), menu_items);
		gtk_widget_show (menu_items);
		gtk_signal_connect (GTK_OBJECT (menu_items), "activate", GTK_SIGNAL_FUNC (menuitem_response), (gpointer) i);
	}

}


void Ajoute_Nouveau_Script (char *buf, int Emplacement)
{
	char     *pBuf;
	int       Taille;

	pBuf = buf;
	/* Recupere le Nom */
	Taille = index (pBuf, ';') - buf;
	Liste_Script[Emplacement].Nom = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Script[Emplacement].Nom, buf, Taille);
	Liste_Script[Emplacement].Nom[Taille] = 0;
	/* Recupere le chemin  */
	pBuf = buf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	Liste_Script[Emplacement].Chemin = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Script[Emplacement].Chemin, pBuf, Taille);
	Liste_Script[Emplacement].Chemin[Taille] = 0;
	/* Recupere les parametres */
	pBuf = pBuf + Taille + 1;
	Taille = index (pBuf, ';') - pBuf;
	Liste_Script[Emplacement].Parametres = malloc (sizeof (char) + Taille + 1);
	strncpy (Liste_Script[Emplacement].Parametres, pBuf, Taille);
	Liste_Script[Emplacement].Parametres[Taille] = 0;
	//printf ("%d >>>> %s %s %s\n", Emplacement, Liste_Script[Emplacement].Nom, Liste_Script[Emplacement].Chemin, Liste_Script[Emplacement].Parametres);
}



void Creer_ScriptList ()
{
	FILE     *Fichier_ScriptList;
	char      buf[512], CheminFichier[256];

	sprintf (CheminFichier, "%s/.AutoScan/Conf/Script", Info_User->pw_dir);
	if ((Fichier_ScriptList = fopen (CheminFichier, "r")) == NULL) {
		perror ("[I] fopen :");
		printf ("[I] Impossible de lire ScriptListe\n");
		exit (-1);
	}
	Nb_Script_Dans_Liste = 0;
	while (fgets (buf, sizeof (buf), Fichier_ScriptList))
		Nb_Script_Dans_Liste++;
	rewind (Fichier_ScriptList);
	Liste_Script = (struct struct_Liste_Script *) malloc (sizeof (struct struct_Liste_Script) * (Nb_Script_Dans_Liste + 1));
	Nb_Script_Dans_Liste = 0;

	while (fgets (buf, sizeof (buf), Fichier_ScriptList)) {
		Ajoute_Nouveau_Script (buf, Nb_Script_Dans_Liste);
		Nb_Script_Dans_Liste++;
	}
	Liste_Script[Nb_Script_Dans_Liste].Nom = NULL;	//FIN
	printf ("[I] Creation de la liste des scripts (%d scripts trouves)\n", Nb_Script_Dans_Liste);
	fclose (Fichier_ScriptList);
}


/*
*
*       Gestion de l'interface
*
*/


void Init_Info_Script ()
{
	/* Initialise l interface */
	Modif_Script = TRUE;	// permet de ne pas prendre en compte les modifications par la fonction Liste_Script_changed
	gtk_entry_set_text (GTK_ENTRY (entry_Ajout_Script_Nom), "");
	gtk_entry_set_text (GTK_ENTRY (combo_entry_Ajout_Script), "");
	gtk_entry_set_text (GTK_ENTRY (entry_Ajout_Script_Parametre), "");
	gtk_widget_set_sensitive (button_Ajout_Script_Ajouter, TRUE);
	gtk_widget_set_sensitive (button_Ajout_Script_Enlever, TRUE);
	gtk_widget_set_sensitive (button_Ajout_Script_Sauvegarder, TRUE);
	gtk_widget_set_sensitive (button_Ajout_Script_Ok, FALSE);
	gtk_widget_set_sensitive (button_Ajout_Script_Annuler, FALSE);
	gtk_widget_set_sensitive (entry_Ajout_Script_Parametre, FALSE);
	gtk_widget_set_sensitive (entry_Ajout_Script_Nom, FALSE);
	gtk_widget_set_sensitive (combo_entry_Ajout_Script, FALSE);
	gtk_widget_set_sensitive (fileentry_Ajout_Script, FALSE);
	Ajout_Script = FALSE;
	Modif_Script = FALSE;
	Script_Selectionner = -1;
}



void on_ajoute_un_script_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	gchar    *text[2];
	int       i;
	GtkCTreeNode *Node;

	Init_Info_Script ();
	gtk_widget_set_sensitive (button_Ajout_Script_Enlever, FALSE);
	gtk_clist_clear (GTK_CLIST (ctree_Ajout_Script));
	gtk_clist_freeze (GTK_CLIST (ctree_Ajout_Script));
	for (i = 0; i < Nb_Script_Dans_Liste; i++) {
		if (Liste_Script[i].Nom != EFFACER) {
			text[0] = g_strdup_printf (Liste_Script[i].Nom);
			text[1] = g_strdup_printf (Liste_Script[i].Chemin);
			Node = gtk_ctree_insert_node (GTK_CTREE (ctree_Ajout_Script), NULL, NULL, text, 5, NULL, NULL, NULL, NULL, FALSE, FALSE);
			gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Ajout_Script), Node, (gpointer *) i);
			Liste_Script[i].Node = Node;
			g_free (text[0]);
			g_free (text[1]);
		}
	}
	gtk_clist_thaw (GTK_CLIST (ctree_Ajout_Script));
	gtk_widget_show (window_Ajout_Script);
}


void on_button_Ajout_Script_Ajouter_clicked (GtkButton * button, gpointer user_data)
{
	Init_Info_Script ();
	printf ("[I] Ajout d'un script\n");
	Ajout_Script = TRUE;
	gtk_widget_set_sensitive (button_Ajout_Script_Ajouter, FALSE);
	gtk_widget_set_sensitive (button_Ajout_Script_Enlever, FALSE);
	gtk_widget_set_sensitive (button_Ajout_Script_Ok, TRUE);
	gtk_widget_set_sensitive (button_Ajout_Script_Annuler, TRUE);
	gtk_widget_set_sensitive (entry_Ajout_Script_Parametre, TRUE);
	gtk_widget_set_sensitive (entry_Ajout_Script_Nom, TRUE);
	gtk_widget_set_sensitive (combo_entry_Ajout_Script, TRUE);
	gtk_widget_set_sensitive (fileentry_Ajout_Script, TRUE);
}


void on_button_Ajout_Script_Enlever_clicked (GtkButton * button, gpointer user_data)
{
	if (Script_Selectionner != -1) {
		printf ("[I] Suppression du script [%s]\n", Liste_Script[Script_Selectionner].Nom);
		gtk_ctree_remove_node (ctree_Ajout_Script, Liste_Script[Script_Selectionner].Node);
		Liste_Script[Script_Selectionner].Nom = EFFACER;
		Script_Selectionner = -1;
		gtk_widget_set_sensitive (button_Ajout_Script_Enlever, FALSE);
		Init_Info_Script ();
	}
}



void on_button_Ajout_Script_Ok_clicked (GtkButton * button, gpointer user_data)
{
	gchar    *text[2];
	char      Tmp[512];
	GtkCTreeNode *Node;

	if (Modif_Script) {
		printf ("[I] Suppression Modification du script [%s]\n", Liste_Script[Script_Selectionner].Nom);
		gtk_ctree_remove_node (ctree_Ajout_Script, Liste_Script[Script_Selectionner].Node);
		Liste_Script[Script_Selectionner].Nom = EFFACER;
	}
	printf ("[I] Ajout du script [%s]\n", gtk_entry_get_text (GTK_ENTRY (entry_Ajout_Script_Nom)));
	sprintf (Tmp, "%s;%s;%s;\n", gtk_entry_get_text (GTK_ENTRY (entry_Ajout_Script_Nom)), gtk_entry_get_text (GTK_ENTRY (combo_entry_Ajout_Script)), gtk_entry_get_text (GTK_ENTRY (entry_Ajout_Script_Parametre)));
	printf ("[I] Buf : [%s]\n", Tmp);
	/* Redimensionne le tableau */
	if ((Liste_Script = realloc (Liste_Script, sizeof (struct struct_Liste_Script) * (Nb_Script_Dans_Liste + 2))) == NULL) {
		printf ("[I] Realloc erreur\n");
		exit (0);
	}
	/* Ajoute le nouveau script dans le tableau */
	Ajoute_Nouveau_Script (Tmp, Nb_Script_Dans_Liste);
	Nb_Script_Dans_Liste++;
	Liste_Script[Nb_Script_Dans_Liste].Nom = FIN;	//FIN   
	/* Affiche la nouvelle entree dans la liste */
	text[0] = g_strdup_printf (Liste_Script[Nb_Script_Dans_Liste - 1].Nom);
	text[1] = g_strdup_printf (Liste_Script[Nb_Script_Dans_Liste - 1].Chemin);
	Node = gtk_ctree_insert_node (GTK_CTREE (ctree_Ajout_Script), NULL, NULL, text, 5, NULL, NULL, NULL, NULL, FALSE, FALSE);
	gtk_ctree_node_set_row_data (GTK_CTREE (ctree_Ajout_Script), Node, (gpointer *) (Nb_Script_Dans_Liste - 1));
	Liste_Script[Nb_Script_Dans_Liste - 1].Node = Node;
	g_free (text[0]);
	g_free (text[1]);
	Init_Info_Script ();
}


void on_button_Ajout_Script_Annuler_clicked (GtkButton * button, gpointer user_data)
{
	if (Modif_Script)
		printf ("[I] Annulation Modification du script [%s]\n", Liste_Script[Script_Selectionner].Nom);
	else
		printf ("[I] Annulation Ajout script\n");
	Init_Info_Script ();
}


void on_ctree_Ajout_Script_tree_select_row (GtkCTree * ctree, GtkCTreeNode * node, gint column, gpointer user_data)
{
	Script_Selectionner = (int) gtk_ctree_node_get_row_data (GTK_CTREE (ctree), node);
	printf ("[I] Script : %d\n", Script_Selectionner);
	Modif_Script = TRUE;	// permet de ne pas prendre en compte les modifications par la fonction Liste_Script_changed
	gtk_entry_set_text (GTK_ENTRY (entry_Ajout_Script_Nom), Liste_Script[Script_Selectionner].Nom);
	gtk_entry_set_text (GTK_ENTRY (combo_entry_Ajout_Script), Liste_Script[Script_Selectionner].Chemin);
	gtk_entry_set_text (GTK_ENTRY (entry_Ajout_Script_Parametre), Liste_Script[Script_Selectionner].Parametres);
	gtk_widget_set_sensitive (button_Ajout_Script_Ajouter, TRUE);
	gtk_widget_set_sensitive (button_Ajout_Script_Enlever, TRUE);
	gtk_widget_set_sensitive (button_Ajout_Script_Ok, FALSE);
	gtk_widget_set_sensitive (button_Ajout_Script_Annuler, FALSE);
	gtk_widget_set_sensitive (entry_Ajout_Script_Parametre, TRUE);
	gtk_widget_set_sensitive (entry_Ajout_Script_Nom, TRUE);
	gtk_widget_set_sensitive (combo_entry_Ajout_Script, TRUE);
	gtk_widget_set_sensitive (fileentry_Ajout_Script, TRUE);
	Modif_Script = FALSE;
}

void Liste_Script_changed (GtkEditable * editable, gpointer user_data)
{
	if ((!Modif_Script) && (!Ajout_Script)) {
		gtk_widget_set_sensitive (button_Ajout_Script_Ajouter, FALSE);
		gtk_widget_set_sensitive (button_Ajout_Script_Enlever, FALSE);
		gtk_widget_set_sensitive (button_Ajout_Script_Sauvegarder, FALSE);
		gtk_widget_set_sensitive (button_Ajout_Script_Ok, TRUE);
		gtk_widget_set_sensitive (button_Ajout_Script_Annuler, TRUE);
		Modif_Script = TRUE;
		printf ("[I] Modifie le script %s\n", Liste_Script[Script_Selectionner].Nom);
	}
}




void on_button_Ajout_Script_Sauvegarder_clicked (GtkButton * button, gpointer user_data)
{
	FILE     *Fichier_ScriptList;
	char      buf[512], CheminFichier[256];
	int       i;

	/* Enregistrement de la liste des scripts */
	sprintf (CheminFichier, "%s/.AutoScan/Conf/Script", Info_User->pw_dir);
	if ((Fichier_ScriptList = fopen (CheminFichier, "w")) == NULL) {
		perror ("[I] fopen :");
		printf ("[I] Impossible de ecrire ScriptListe\n");
		exit (-1);
	}
	for (i = 0; i < Nb_Script_Dans_Liste; i++) {
		if (Liste_Script[i].Nom != EFFACER) {
			sprintf (buf, "%s;%s;%s;\n", Liste_Script[i].Nom, Liste_Script[i].Chemin, Liste_Script[i].Parametres);
			/* Enregistrement */
			if (fputs (buf, Fichier_ScriptList) != 1)
				printf ("[I] Erreur Ecriture fichier ScriptListe\n");
		}
	}
	fclose (Fichier_ScriptList);
	/* Libere la liste des scripts (A finir tout n'est pas libérer !!!) */
	free (Liste_Script);
	/* Créer une nouvelle liste avec le contenu du fichier */
	Creer_ScriptList ();
	gtk_widget_hide (window_Ajout_Script);
	Creer_Menu_Script ();
}
