/*
 *  Copyright (C) 2004 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Reseau.h"
#include "Machine.h"


gboolean Envoie_Donnee (int Socket, char *Donnee, char *Reponse)
{
	int       NbOctet;
	char      Temp[255], *chaine;

	if ((NbOctet = send (Socket, Donnee, strlen (Donnee), 0)) == 0) {
		printf ("Envoie Mail Erreur\n");
		close (Socket);
		return FALSE;
	}

	if ((NbOctet = recv (Socket, Temp, sizeof (Temp), 0)) == 0) {
		printf ("Reception Mail Erreur\n");
		close (Socket);
		return FALSE;
	}
	Temp[NbOctet] = 0;
	printf ("Command : %s#  ---> [%s]\n", Donnee,Temp);
	if (strncmp (Temp, Reponse, strlen (Reponse)) != 0) {
		printf ("Erreur SMTP !!!\n");
		return FALSE;
	}
	return TRUE;
}


gboolean Envoie_Email (int Machine, char *To, char *From, char *Objet, char *donnee)
{
	struct hostent *host;
	int       Socket;
	int       NbOctet;
	char      Temp[255], *chaine, *Domain;

	printf ("Envoie d'un email  la machine %d  de %s    %s  \nDonnee : [%s]\n", Machine, To, From, donnee);
	if ((host = resoudre_DNS (Liste_Machines[MachineSelectionner].Adresse_Ip)) == NULL) {
		close (Socket);
		return FALSE;
	}
	Socket = Creation_Socket_TCP ();
	if (connection_Serveur (Liste_Machines[MachineSelectionner].Adresse_Ip, host, SMTP, Socket) == FALSE) {
		printf ("Impossible de se connecter\n");
		close (Socket);
		return FALSE;
	}

	printf ("Recupration de l'en-tete\n");
	if ((NbOctet = recv (Socket, Temp, sizeof (Temp), 0)) == 0) {
		printf ("Reception En-tete\n");
		close (Socket);
		return FALSE;
	}
	Temp[NbOctet] = 0;
	printf ("En-tete[%s]\n", Temp);
	Domain = index (From, '@') + 1;
	printf ("Domain : %s\n", Domain);
	sprintf (Temp, "HELO %s\r\n", Domain);
	if (!Envoie_Donnee (Socket, Temp, "250"))
		return FALSE;
	sprintf (Temp, "MAIL FROM:<%s>\r\n", To);
	if (!Envoie_Donnee (Socket, Temp, "250"))
		return FALSE;
	sprintf (Temp, "RCPT TO:<%s>\r\n", From);
	if (!Envoie_Donnee (Socket, Temp, "250"))
		return FALSE;
	if (!Envoie_Donnee (Socket, "DATA\r\n", "354"))
		return FALSE;
	sprintf (Temp, "Subject: %s\r\n\r\n%s\r\n", Objet, donnee);
	if ((NbOctet = send (Socket, Temp, strlen (Temp), 0)) == 0) {
		printf ("Envoie Mail From Erreur\n");
		close (Socket);
		return FALSE;
	}
	if (!Envoie_Donnee (Socket, "\r\n.\r\n", "250"))
		return FALSE;
	if (!Envoie_Donnee (Socket, "QUIT\r\n", "221"))
		return FALSE;
	close (Socket);
	return TRUE;

}
